# 靖安县水环境监测与河湖管理APP 此项目包括**领导版**、**业务版**、**公众版**三个版本。
## 版本布局
1. 初始化入口login.html
2. 领导版入口html/ledVersion.html
    - 首页 tab-led-home.html
	- 巡河 html/home/riverPatrol/riverPatrolLog-2.html
	- 上报 html/home/riverPatrol/reportRiverPatrolEvent.html
	- 我的 html/tab-subpage-mine.html
3. 业务版入口html/businessVersion.html
    - 首页 html/tab-subpage-home.html
	- 巡河 html/home/riverPatrol/riverPatrolLog-2.html
	- 上报 html/home/riverPatrol/reportRiverPatrolEvent.html
	- 我的 html/tab-subpage-mine.html
4. 公众版入口publicHtml.html
    - 首页 publicHtml/tab-webview-subpage-main.html
	- 通讯录 publicHtml/tab-webview-subpage-addressBook.html
	- 随手拍 publicHtml/EReport.html
	- 金点子 publicHtml/tab-webview-subpage-goldenIdea.html.html
	- 我的 html/tab-subpage-mine.html

## 目录结构
```tree
│  .gitignore
│  index.js
│  login.html
│  manifest.json
│  publicVersion.html
│  README.md
│  register.html
│  
├─common
│  │  checkeds.html
│  │  
│  ├─audio
│  │  │  index.html
│  │  │  
│  │  ├─audio
│  │  │      example-2.mp3
│  │  │      
│  │  ├─css
│  │  │      main.min.css
│  │  │      
│  │  └─js
│  │          audio.js
│  │          
│  ├─audio0
│  │  │  index.html
│  │  │  index1.html
│  │  │  
│  │  ├─css
│  │  │      style.css
│  │  │      
│  │  ├─js
│  │  │      jquery.min.js
│  │  │      jweixin-1.0.0.js
│  │  │      
│  │  └─mp3
│  │          alice.mp3
│  │          
│  ├─calendar
│  │  │  index.html
│  │  │  
│  │  ├─css
│  │  │      calendar.css
│  │  │      common.css
│  │  │      
│  │  ├─image
│  │  │      bg_signIn.png
│  │  │      
│  │  └─js
│  │          calendar.js
│  │          
│  └─process
│      │  index.html
│      │  
│      ├─css
│      │      index-debug.css
│      │      index.css
│      │      
│      ├─images
│      │      btn-bg.jpg
│      │      circle-active.png
│      │      circle.png
│      │      ling-bg.jpg
│      │      success.png
│      │      
│      └─static
│          └─lib
│              ├─jquery
│              │      jquery.min.js
│              │      
│              └─jquery-step
│                  ├─css
│                  │      jquery.step.css
│                  │      
│                  ├─images
│                  │      bar-bg-active.png
│                  │      bar-bg.png
│                  │      cell-active.png
│                  │      cell.png
│                  │      
│                  └─js
│                          jquery.step.js
│                          
├─css
│  │  common.css
│  │  common2.css
│  │  demo-center.css
│  │  element-ui.min.css
│  │  iconfont.css
│  │  index.css
│  │  login.css
│  │  mui.css
│  │  mui.dtpicker.css
│  │  mui.min.css
│  │  mui.picker.css
│  │  mui.poppicker.css
│  │  mui.previewimage.css
│  │  mui.pullToRefresh.css
│  │  public.css
│  │  
│  ├─DataStatistics
│  │      dataStatisticsMain.css
│  │      hydrologyStatistics.css
│  │      
│  ├─EventReport
│  │      eventReportMain.css
│  │      feedback.css
│  │      mapLocation.css
│  │      
│  ├─EventTask
│  │      eventTaskDetails.css
│  │      eventTaskMain.css
│  │      
│  ├─MonitoreStation
│  │      mapShow.css
│  │      monitoreStationMain.css
│  │      
│  ├─pdf
│  │      jquery.touchPDF.css
│  │      pdf.css
│  │      
│  ├─publicCss
│  │  ├─goldenIdea
│  │  │      feedback.css
│  │  │      goldenIdea.css
│  │  │      
│  │  └─home
│  │      │  intro-list.css
│  │      │  
│  │      └─MonitoreStation
│  │              mapShow.css
│  │              monitoreStationMain.css
│  │              
│  └─setting
│          feedback.css
│          feedbackStatistic_hotPoint.css
│          feedback_hotPoint.css
│          forgetPass.css
│          messageDetails.css
│          mui.pullToRefresh.css
│          my_page.css
│          
├─fonts
│      iconfont.ttf
│      mui.ttf
│      
├─html
│  │  businessVersion.html
│  │  ledVersion.html
│  │  tab-led-home.html
│  │  tab-subpage-home.html
│  │  tab-subpage-info.html
│  │  tab-subpage-map.html
│  │  tab-subpage-mine.html
│  │  
│  ├─DataStatistics
│  │      eventStatistics.html
│  │      hydrologyStatistics.html
│  │      rainfallConditionStatistics.html
│  │      waterQualityStatistics.html
│  │      
│  ├─home
│  │  ├─aggregateAnalysis
│  │  │      aggregateAnalysis.html
│  │  │      tab-subpage-district.html
│  │  │      tab-subpage-unit.html
│  │  │      
│  │  ├─attendanceManagement
│  │  │      attendanceManagement.html
│  │  │      
│  │  ├─best-practices
│  │  │  └─list-to-detail
│  │  │          detail.html
│  │  │          list-to-detail.css
│  │  │          list-to-detail1.css
│  │  │          listview.html
│  │  │          newdetail.html
│  │  │          newdetail1.html
│  │  │          vue.min.js
│  │  │          
│  │  ├─check
│  │  │      check.html
│  │  │      checkDetail.html
│  │  │      
│  │  ├─EventHandil
│  │  │  ├─EventBack
│  │  │  │      eventBack.html
│  │  │  │      
│  │  │  ├─EventDetail
│  │  │  │      eventDetail.css
│  │  │  │      eventDetail.html
│  │  │  │      
│  │  │  ├─EventList
│  │  │  │      eventList.css
│  │  │  │      eventList.html
│  │  │  │      
│  │  │  ├─EventMap
│  │  │  │      eventMap.html
│  │  │  │      
│  │  │  ├─EventProcess
│  │  │  │      chart.js
│  │  │  │      eventProcess.css
│  │  │  │      eventProcess.html
│  │  │  │      
│  │  │  ├─EventSearch
│  │  │  │      eventSearch.css
│  │  │  │      eventSearch.html
│  │  │  │      
│  │  │  ├─EventUpdateDetail
│  │  │  │      eventUpdateDetail-old.html
│  │  │  │      eventUpdateDetail.css
│  │  │  │      eventUpdateDetail.html
│  │  │  │      
│  │  │  └─EventView
│  │  │          eventView.css
│  │  │          eventView.html
│  │  │          
│  │  ├─EventReport
│  │  │      camera_video.html
│  │  │      eventReportList (2).html
│  │  │      eventReportList.html
│  │  │      eventReportMain.html
│  │  │      mapLocation.html
│  │  │      patrolTaskMap.html
│  │  │      
│  │  ├─EventSupervise
│  │  │      eventTaskDetails.html
│  │  │      eventTaskList.html
│  │  │      eventTaskScreen.html
│  │  │      
│  │  ├─EventTask
│  │  │      eventApprovalFlow.html
│  │  │      eventTaskDetails.html
│  │  │      eventTaskMain.html
│  │  │      
│  │  ├─feedback
│  │  │  ├─Feedback
│  │  │  │      feedback.css
│  │  │  │      feedback.html
│  │  │  │      
│  │  │  ├─FeedbackUpdate
│  │  │  │      updateDetail.css
│  │  │  │      updateDetail.html
│  │  │  │      
│  │  │  └─Idea
│  │  │          idea.css
│  │  │          idea.html
│  │  │          ideaDetail.css
│  │  │          ideaDetail.html
│  │  │          
│  │  ├─GovernmentalInfo
│  │  │  ├─InfosDetail
│  │  │  │      infosDetail.css
│  │  │  │      infosDetail.html
│  │  │  │      
│  │  │  ├─InfoSearch
│  │  │  │      infoSearch.html
│  │  │  │      
│  │  │  ├─NoticeInfos
│  │  │  │      noticeInfos.css
│  │  │  │      noticeInfos.html
│  │  │  │      
│  │  │  └─UpToDateState
│  │  │          upToDateState.css
│  │  │          upToDateState.html
│  │  │          
│  │  ├─history
│  │  │      history.html
│  │  │      
│  │  ├─riverPatrol
│  │  │  │  reportRiverPatrolEvent.html
│  │  │  │  riverPatrolLog-2-baidu.html
│  │  │  │  riverPatrolLog-2-pluscopy.html
│  │  │  │  riverPatrolLog-2-plustest.html
│  │  │  │  riverPatrolLog-2-system.html
│  │  │  │  riverPatrolLog-2.html
│  │  │  │  riverPatrolLogHistory.html
│  │  │  │  
│  │  │  └─VerifyVerification
│  │  │          verifyVerification.css
│  │  │          verifyVerification.html
│  │  │          
│  │  ├─riversMonitor
│  │  │  ├─HydrologicMonitoring
│  │  │  │      hydrologicDetail.css
│  │  │  │      hydrologicDetail.html
│  │  │  │      hydrologicMonitoring.css
│  │  │  │      hydrologicMonitoring.html
│  │  │  │      
│  │  │  ├─WarningDetail
│  │  │  │      warningDetail.css
│  │  │  │      warningDetail.html
│  │  │  │      
│  │  │  ├─WaterQuality
│  │  │  │      waterQuality.css
│  │  │  │      waterQuality.html
│  │  │  │      
│  │  │  └─WaterQualityDetail
│  │  │          waterQualityDetail.css
│  │  │          waterQualityDetail.html
│  │  │          
│  │  ├─sinceDisposal
│  │  │      sinceDisposal.html
│  │  │      
│  │  └─statisticAnalysis
│  │          statisticAnalysis.html
│  │          tab-subpage-event.html
│  │          tab-subpage-watequality.html
│  │          
│  ├─info
│  │  │  infoDetails.html
│  │  │  info_data_doc.html
│  │  │  info_data_list.html
│  │  │  lvzhi_info.html
│  │  │  mail_list.html
│  │  │  pdf.html
│  │  │  
│  │  └─MonitoreStation
│  │          mapShow.html
│  │          monitoreStationMain.html
│  │          search.html
│  │          
│  ├─map
│  │      webview_mask_side-bak.html
│  │      webview_mask_side.html
│  │      
│  ├─mine
│  │  │  aboutUs.html
│  │  │  advice.html
│  │  │  changePassage.html
│  │  │  my_setting.html
│  │  │  signIn.html
│  │  │  
│  │  ├─AttendanceManage
│  │  │      AttendanceIndex.html
│  │  │      index.html
│  │  │      index_2.html
│  │  │      tab-clockin.html
│  │  │      tab-statistics.html
│  │  │      wuliu.html
│  │  │      
│  │  ├─setting
│  │  │  └─settingMore
│  │  │          aboutAPP.html
│  │  │          advice.html
│  │  │          publish.html
│  │  │          
│  │  └─UpDateInfo
│  │          upDateInfo.html
│  │          
│  ├─setting
│  │      message_details.html
│  │      my_collect.html
│  │      my_message.html
│  │      my_onling_help.html
│  │      my_page.html
│  │      qr_code.html
│  │      showCollect.html
│  │      
│  └─video
│          video_play.html
│          
├─images
├─js
│  │  amap.js
│  │  app.js
│  │  appUtil.js
│  │  audio.js
│  │  Base64.js
│  │  common.js
│  │  common2.js
│  │  dateutil.js
│  │  element-ui.main.js
│  │  flexible.js
│  │  jquery-1.11.2.min.js
│  │  map.js
│  │  mui.dtpicker.js
│  │  mui.enterfocus.js
│  │  mui.js
│  │  mui.lazyload.img.js
│  │  mui.lazyload.js
│  │  mui.min.js
│  │  mui.picker.js
│  │  mui.poppicker.js
│  │  mui.previewimage.js
│  │  mui.pullToRefresh.js
│  │  mui.pullToRefresh.material.js
│  │  mui.zoom.js
│  │  public.js
│  │  template-native.js
│  │  verification-code.js
│  │  video.js
│  │  vue.2.6.11.main.js
│  │  vue.js
│  │  webviewGroup.js
│  │  
│  ├─data
│  │  │  areaInfo.js
│  │  │  dataStatistics.js
│  │  │  eventTaskInfo.js
│  │  │  eventTyper.js
│  │  │  guiji.js
│  │  │  hydrologydata.js
│  │  │  jax.geojson
│  │  │  layerData.js
│  │  │  newsData.js
│  │  │  newsList.json
│  │  │  pdfList.js
│  │  │  stationInfo.js
│  │  │  watequality.js
│  │  │  
│  │  └─pdf
│  │          1.pdf
│  │          2.pdf
│  │          3.pdf
│  │          
│  ├─echarts
│  │      echarts.5.0.min.js
│  │      echarts.min.js
│  │      
│  ├─flexible
│  │      flexible.js
│  │      
│  ├─jqUi
│  │  ├─jqDate
│  │  │      jdate.js
│  │  │      
│  │  ├─jqModal
│  │  │      modal.css
│  │  │      modal.js
│  │  │      
│  │  ├─mobileSelect
│  │  │      mobileSelect.css
│  │  │      mobileSelect.js
│  │  │      
│  │  ├─page
│  │  │      page.css
│  │  │      page.js
│  │  │      
│  │  └─table
│  │          table.css
│  │          table.js
│  │          
│  ├─map
│  │      addToolbar.js
│  │      Amap1.4.15.js
│  │      Amap2.0.js
│  │      AmapUi.js
│  │      demoutils.js
│  │      initMap.js
│  │      maps.js
│  │      mapUntil.js
│  │      trackPlay.js
│  │      
│  ├─pdf
│  │      jquery.mousewheel.js
│  │      jquery.panzoom.js
│  │      jquery.touchPDF.js
│  │      jquery.touchSwipe.js
│  │      pdf.compatibility.js
│  │      pdf.js
│  │      pdf.worker.js
│  │      
│  └─until
│          hashmap.js
│          NativeUtil.js
│          util.js
│          
├─libs
│  │  echarts.js
│  │  echarts.min.js
│  │  
│  ├─calendar
│  │      calendar.css
│  │      calendar.js
│  │      
│  ├─easymob-webim-sdk
│  │      easemob.im-1.0.5.js
│  │      jquery-1.11.1.js
│  │      json2.js
│  │      quickstart.md
│  │      strophe-custom-2.0.0.js
│  │      
│  └─qiao
│          qiao.h.js
│          
├─publicHtml
│  │  EReport.html
│  │  mapLocation.html
│  │  tab-webview-subpage-addressBook.html
│  │  tab-webview-subpage-goldenIdea.html
│  │  tab-webview-subpage-main.html
│  │  
│  └─home
│      ├─best-practices
│      │  └─list-to-detail
│      │          detail.html
│      │          list-to-detail.css
│      │          list-to-detail1.css
│      │          listview.html
│      │          newdetail.html
│      │          newdetail1.html
│      │          vue.min.js
│      │          
│      ├─chiefDetail
│      │      index.css
│      │      index.html
│      │      
│      └─MonitoreStation
│              mapShow.html
│              monitoreStationMain.html
│              search.html
│              
└─unpackage
```