"use strict";

function _slicedToArray(a, b) {
	return _arrayWithHoles(a) || _iterableToArrayLimit(a, b) || _nonIterableRest()
}

function _nonIterableRest() {
	throw new TypeError("Invalid attempt to destructure non-iterable instance")
}

function _iterableToArrayLimit(g, j) {
	var a = [];
	var e = true;
	var b = false;
	var c = undefined;
	try {
		for (var d = g[Symbol.iterator](), f; !(e = (f = d.next()).done); e = true) {
			a.push(f.value);
			if (j && a.length === j) {
				break
			}
		}
	} catch (h) {
		b = true;
		c = h
	} finally {
		try {
			if (!e && d["return"] != null) {
				d["return"]()
			}
		} finally {
			if (b) {
				throw c
			}
		}
	}
	return a
}

function _arrayWithHoles(a) {
	if (Array.isArray(a)) {
		return a
	}
}

function _classCallCheck(b, a) {
	if (!(b instanceof a)) {
		throw new TypeError("Cannot call a class as a function")
	}
}

function _defineProperties(d, c) {
	for (var b = 0; b < c.length; b++) {
		var a = c[b];
		a.enumerable = a.enumerable || false;
		a.configurable = true;
		if ("value" in a) {
			a.writable = true
		}
		Object.defineProperty(d, a.key, a)
	}
}

function _createClass(a, b, c) {
	if (b) {
		_defineProperties(a.prototype, b)
	}
	if (c) {
		_defineProperties(a, c)
	}
	return a
}
var GreenAudioPlayer = function() {
	function g(r) {
		_classCallCheck(this, g);
		this.audioPlayer = document.querySelector(r);
		var q = this.audioPlayer.innerHTML;
		this.audioPlayer.classList.add("green-audio-player");
		this.audioPlayer.innerHTML = g.getTemplate() + q;
		this.playPause = this.audioPlayer.querySelector(".play-pause-btn__icon");
		this.playPauseBtn = this.audioPlayer.querySelector(".play-pause-btn");
		this.loading = this.audioPlayer.querySelector(".loading");
		this.sliders = this.audioPlayer.querySelectorAll(".slider");
		this.progress = this.audioPlayer.querySelector(".controls__progress");
		this.volumeBtn = this.audioPlayer.querySelector(".volume__button");
		this.volumeControls = this.audioPlayer.querySelector(".volume__controls");
		this.volumeProgress = this.volumeControls.querySelector(".volume__progress");
		this.player = this.audioPlayer.querySelector("audio");
		this.currentTime = this.audioPlayer.querySelector(".controls__current-time");
		this.totalTime = this.audioPlayer.querySelector(".controls__total-time");
		this.speaker = this.audioPlayer.querySelector(".volume__speaker");
		this.draggableClasses = ["pin"];
		this.currentlyDragged = null;
		this.initEvents();
		this.directionAware()
	}
	_createClass(g, [{
		key: "initEvents",
		value: function i() {
			var q = this;
			var r = this;
			r.audioPlayer.addEventListener("mousedown", function(s) {
				if (r.isDraggable(s.target)) {
					r.currentlyDragged = s.target;
					var t = r.currentlyDragged.dataset.method;
					var u = r[t].bind(r);
					window.addEventListener("mousemove", u, false);
					window.addEventListener("mouseup", function() {
						r.currentlyDragged = false;
						window.removeEventListener("mousemove", u, false)
					}, false)
				}
			});
			r.audioPlayer.addEventListener("touchstart", function(t) {
				if (r.isDraggable(t.target)) {
					var s = _slicedToArray(t.targetTouches, 1);
					r.currentlyDragged = s[0];
					var u = r.currentlyDragged.target.dataset.method;
					var v = r[u].bind(r);
					window.addEventListener("touchmove", v, false);
					window.addEventListener("touchend", function() {
						r.currentlyDragged = false;
						window.removeEventListener("touchmove", v, false)
					}, false);
					t.preventDefault()
				}
			});
			this.playPauseBtn.addEventListener("click", this.togglePlay.bind(r));
			this.player.addEventListener("timeupdate", this.updateProgress.bind(r));
			this.player.addEventListener("volumechange", this.updateVolume.bind(r));
			this.player.addEventListener("loadedmetadata", function() {
				q.totalTime.textContent = g.formatTime(r.player.duration)
			});
			this.player.addEventListener("seeking", this.showLoadingIndicator.bind(r));
			this.player.addEventListener("canplay", this.hideLoadingIndicator.bind(r));
			this.player.addEventListener("ended", function() {
				r.playPause.attributes.d.value = "M18 12L0 24V0";
				r.player.currentTime = 0
			});
			this.volumeBtn.addEventListener("click", function() {
				r.volumeBtn.classList.toggle("open");
				r.volumeControls.classList.toggle("hidden")
			});
			window.addEventListener("resize", r.directionAware.bind(r));
			window.addEventListener("scroll", r.directionAware.bind(r));
			this.sliders.forEach(function(t) {
				var s = t.querySelector(".pin");
				t.addEventListener("click", r[s.dataset.method].bind(r))
			})
		}
	}, {
		key: "isDraggable",
		value: function k(s) {
			var q = false;
			var r = Array.from(s.classList);
			this.draggableClasses.forEach(function(t) {
				if (r.indexOf(t) !== -1) {
					q = true
				}
			});
			return q
		}
	}, {
		key: "inRange",
		value: function j(t) {
			var y = "touches" in t;
			var w = this.getRangeBox(t);
			var x = w.getBoundingClientRect();
			var s = w.dataset.direction;
			var v = null;
			var u = null;
			if (s === "horizontal") {
				v = w.offsetLeft;
				u = v + w.offsetWidth;
				var q = y ? t.touches[0].clientX : t.clientX;
				if (q < v || q > u) {
					return false
				}
			} else {
				v = x.top;
				u = v + w.offsetHeight;
				var r = y ? t.touches[0].clientY : t.clientY;
				if (r < v || r > u) {
					return false
				}
			}
			return true
		}
	}, {
		key: "updateProgress",
		value: function o() {
			var q = this.player.currentTime;
			var r = q / this.player.duration * 100;
			this.progress.style.width = "".concat(r, "%");
			this.currentTime.textContent = g.formatTime(q)
		}
	}, {
		key: "updateVolume",
		value: function p() {
			this.volumeProgress.style.height = "".concat(this.player.volume * 100, "%");
			if (this.player.volume >= 0.5) {
				this.speaker.attributes.d.value =
					"M14.667 0v2.747c3.853 1.146 6.666 4.72 6.666 8.946 0 4.227-2.813 7.787-6.666 8.934v2.76C20 22.173 24 17.4 24 11.693 24 5.987 20 1.213 14.667 0zM18 11.693c0-2.36-1.333-4.386-3.333-5.373v10.707c2-.947 3.333-2.987 3.333-5.334zm-18-4v8h5.333L12 22.36V1.027L5.333 7.693H0z"
			} else {
				if (this.player.volume < 0.5 && this.player.volume > 0.05) {
					this.speaker.attributes.d.value =
						"M0 7.667v8h5.333L12 22.333V1L5.333 7.667M17.333 11.373C17.333 9.013 16 6.987 14 6v10.707c2-.947 3.333-2.987 3.333-5.334z"
				} else {
					if (this.player.volume <= 0.05) {
						this.speaker.attributes.d.value = "M0 7.667v8h5.333L12 22.333V1L5.333 7.667"
					}
				}
			}
		}
	}, {
		key: "getRangeBox",
		value: function e(r) {
			var s = r.target;
			var q = this.currentlyDragged;
			if (r.type === "click" && this.isDraggable(r.target)) {
				s = r.target.parentElement.parentElement
			}
			if (r.type === "mousemove") {
				s = q.parentElement.parentElement
			}
			if (r.type === "touchmove") {
				s = q.target.parentElement.parentElement
			}
			return s
		}
	}, {
		key: "getCoefficient",
		value: function d(s) {
			var z = "touches" in s;
			var y = this.getRangeBox(s);
			var x = y.getBoundingClientRect();
			var u = 0;
			if (y.dataset.direction === "horizontal") {
				var q = z ? s.touches[0].clientX : s.clientX;
				var v = q - y.offsetLeft;
				var A = y.clientWidth;
				u = v / A
			} else {
				if (y.dataset.direction === "vertical") {
					var t = y.clientHeight;
					var r = z ? s.touches[0].clientY : s.clientY;
					var w = r - x.top;
					u = 1 - w / t
				}
			}
			return u
		}
	}, {
		key: "rewind",
		value: function l(q) {
			if (this.inRange(q)) {
				this.player.currentTime = this.player.duration * this.getCoefficient(q)
			}
		}
	}, {
		key: "changeVolume",
		value: function a(q) {
			if (this.inRange(q)) {
				this.player.volume = Math.round(this.getCoefficient(q) * 10) / 10
			}
		}
	}, {
		key: "togglePlay",
		value: function n() {
			if (this.player.paused) {
				this.playPause.attributes.d.value = "M0 0h6v24H0zM12 0h6v24h-6z";
				this.player.play()
			} else {
				this.playPause.attributes.d.value = "M18 12L0 24V0";
				this.player.pause()
			}
		}
	}, {
		key: "showLoadingIndicator",
		value: function m() {
			this.playPauseBtn.style.display = "none";
			this.loading.style.display = "block"
		}
	}, {
		key: "hideLoadingIndicator",
		value: function h() {
			this.playPauseBtn.style.display = "block";
			this.loading.style.display = "none"
		}
	}, {
		key: "directionAware",
		value: function b() {
			this.volumeControls.classList.remove("top", "middle", "bottom");
			if (window.innerHeight < 250) {
				this.volumeControls.classList.add("middle")
			} else {
				if (this.audioPlayer.getBoundingClientRect().top < 154) {
					this.volumeControls.classList.add("bottom")
				} else {
					this.volumeControls.classList.add("top")
				}
			}
		}
	}], [{
		key: "getTemplate",
		value: function f() {
			return '\n            <div class="loading">\n                <div class="loading__spinner"></div>\n            </div>\n            <div class="play-pause-btn">\n                <svg xmlns="http://www.w3.org/2000/svg" width="18" height="24" viewBox="0 0 18 24">\n                    <path fill="#566574" fill-rule="evenodd" d="M18 12L0 24V0" class="play-pause-btn__icon"/>\n                </svg>\n            </div>\n    \n            <div class="controls">\n                <span class="controls__current-time">0:00</span>\n                <div class="controls__slider slider" data-direction="horizontal">\n                    <div class="controls__progress progress">\n                        <div class="pin progress__pin" data-method="rewind"></div>\n                    </div>\n                </div>\n                <span class="controls__total-time">0:00</span>\n            </div>\n    \n            <div class="volume">\n                <div class="volume__button">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24">\n                        <path class="volume__speaker" fill="#566574" fill-rule="evenodd" d="M14.667 0v2.747c3.853 1.146 6.666 4.72 6.666 8.946 0 4.227-2.813 7.787-6.666 8.934v2.76C20 22.173 24 17.4 24 11.693 24 5.987 20 1.213 14.667 0zM18 11.693c0-2.36-1.333-4.386-3.333-5.373v10.707c2-.947 3.333-2.987 3.333-5.334zm-18-4v8h5.333L12 22.36V1.027L5.333 7.693H0z"/>\n                    </svg>\n                </div>\n                <div class="volume__controls hidden">\n                    <div class="volume__slider slider" data-direction="vertical">\n                        <div class="volume__progress progress">\n                            <div class="pin volume__pin" data-method="changeVolume"></div>\n                        </div>\n                    </div>\n                </div>\n            </div>\n            \n        '
		}
	}, {
		key: "formatTime",
		value: function c(s) {
			var q = Math.floor(s / 60);
			var r = Math.floor(s % 60);
			return "".concat(q, ":").concat(r < 10 ? "0".concat(r) : r)
		}
	}]);
	return g
}();
window.GreenAudioPlayer = GreenAudioPlayer;
