const y = 260;
const x = 400;
const color = [
	'#c23531', '#2f4554', '#61a0a8', '#d48265', '#91c7ae', '#749f83',
	'#ca8622', '#bda29a', '#6e7074', '#546570', '#c4ccd3'
];
function changeChartOptions (data, current, history) {
	console.log(JSON.stringify(history))
	console.log(current)
	const OPTIONS = {
		
			tooltip: {
			confine: true,
			// formatter: (e) => {
			// 	let title = '';
			// 	const { dataIndex, name } = e;
			// 	if(dataIndex === current) {
			// 		title = '待办';
			// 	} else if(history.includes(dataIndex)) {
			// 		title = '已办';
			// 	} else {
			// 		title = '';
			// 	}
			// 	return `<strong>${title}</strong><br /><span>${name}</span>`
			// }
		},
		animationDurationUpdate: 1500,
		animationEasingUpdate: 'quinticInOut',
		series: [{
			type: 'graph',
			layout: 'none',
			symbolSize: [70, 40],
			symbol: 'rect',
			roam: false,
			itemStyle: {
				normal: {
					color: function(params) {
						if(params.dataIndex === current) {
							return '#719EEB'
						}
						if(history.includes(params.dataIndex)) {
							// return 'rgba(0,81,255, 0.6)'
							return '#F0BA71'
						}
						return '#AAAAAA'
					},
				}
			},
			label: {
				show: true,
				width: 70,
				overflow: 'break',
				align: 'center',
				color: '#fff'
			},
			edgeSymbol: ['circle', 'arrow'],
			//   edgeSymbolSize: [4, 10],
			edgeLabel: {
				fontSize: 16
			},
			data,
			// links: [],
			links: [
				//   保洁 - 村级河长
				{
					source: 0,
					target: 1,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 1,
					target: 0,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '指派'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.5,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 村级河长 - 乡镇
				{
					source: 1,
					target: 2,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 2,
					target: 1,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '移交'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.5,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 乡镇 - 县河长办
				{
					source: 2,
					target: 3,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 3,
					target: 2,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '移交'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.5,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 县河长办 - 县级总河长
				{
					source: 3,
					target: 4,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 4,
					target: 3,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '移交'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.5,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 乡镇河长 - 乡镇人民
				{
					source: 2,
					target: 5,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '交办'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 5,
					target: 2,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '反馈'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.6,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 乡镇河长 - 县人民
				{
					source: 3,
					target: 6,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '交办'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.4,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 6,
					target: 3,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '反馈'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.45,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 乡河长 - 县河长
				{
					source: 7,
					target: 3,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.4,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 3,
					target: 7,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '移交'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: 0.4,
						color: 'rgba(0,0,0,.65)',
					},
				},
				// 乡河长 - 乡镇河长办
				{
					source: 7,
					target: 2,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '移交'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						height: 20,
						curveness: -0.3,
						color: 'rgba(0,0,0,.65)',
					},
				},
				{
					source: 2,
					target: 7,
					symbolSize: 5,
					label: {
						show: true,
						formatter: () => {
							return '报告'
						},
						color: 'rgba(0,0,0,.65)',
					},
					lineStyle: {
						width: 1,
						curveness: -0.3,
						color: 'rgba(0,0,0,.65)',
					},
				},
			],
			lineStyle: {
				opacity: 0.9,
				width: 2,
				curveness: 0
			}
		}]
	};
	return OPTIONS;
}