const MAP_CONFIG = {
	defaultLayer: 'vec',
	baseLayers: [{
			alias: '标准地图',
			image: 'images/map/bg_map_vec.png',
			name: 'vec',
			visible: true,
			config: ['default']
		},
		{
			alias: '卫星地图',
			image: 'images/map/bg_map_img.png',
			name: 'img',
			visible: false,
			config: ['Satellite', 'RoadNet']
		},
	],
	layerGroup: [{
			"id": "0158336bce132v9282de583367510107",
			"alias": "河流信息",
			"name": "river_source",
			"icon": "iconyinyongshuiyuan-xuan",
			"image": 'images/map/hhxx.png',
			"count": "71",
			"unit": "条",
			"active": "color3",
			"type": "geoVector",
			"url": "",
			"visible": true,
			"click": true,
			"info": {
				"title": "河流信息",
				"field": {
					"name": {
						"name": "河流名称",
						"type": "string"
					},
					"rvSourLoc": {
						"name": "河源所在位置",
						"type": "string"
					},
					"rvMouLoc": {
						"name": "河口所在位置",
						"type": "string"
					},
					"rvLen": {
						"name": "河流长度（km）",
						"type": "string"
					},
					"rvBasArea": {
						"name": "河流流域面积（k㎡）",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "水功能区",
			"name": "water_source_gcj02",
			"icon": "iconshuigongnengqu-xuan",
			"image": 'images/map/sgnq.png',
			"count": "9",
			"unit": "个",
			"type": "wms",
			"active": "color2",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"visible": false,
			"click": true,
			"info": {
				"title": "水功能区",
				"field": {
					"河流湖库": {
						"name": "河流湖库",
						"type": "string"
					},
					"控制城镇": {
						"name": "控制城镇",
						"type": "string"
					},
					"水功能区名": {
						"name": "水功能区名",
						"type": "string"
					},
					"水质目标": {
						"name": "水质目标",
						"type": "string"
					},
					"水质现状": {
						"name": "水质现状",
						"type": "string"
					},
					"起始": {
						"name": "起始",
						"type": "string"
					},
					"终止": {
						"name": "终止",
						"type": "string"
					},
					"区划依据": {
						"name": "区划依据",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "饮用水源地",
			"name": "waterSource",
			"icon": "iconyinyongshuiyuan-xuan",
			"image": 'images/map/yysyd.png',
			"count": "2",
			"unit": "个",
			"active": "color3",
			"type": "pointVector",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"visible": true,
			"click": true,
			"info": {
				"title": "饮用水源地",
				"field": {
					"name": {
						"name": "名称",
						"type": "string"
					},
					"county": {
						"name": "县(区、市)",
						"type": "string"
					},
					"city": {
						"name": "设区市",
						"type": "string"
					},
					"town": {
						"name": "乡(镇)",
						"type": "string"
					},
					"toObject": {
						"name": "供水对象",
						"type": "string"
					},
					"waterType": {
						"name": "水源类型",
						"type": "string"
					},
					"waterStatus": {
						"name": "水源状态",
						"type": "string"
					},
					"reserveText": {
						"name": "保护区文号",
						"type": "string"
					},
					"reserve": {
						"name": "保护区划定情况",
						"type": "string"
					},
					"size": {
						"name": "工程设计供水规模（吨/天）",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "入河排污口",
			"name": "riverPollution",
			"icon": "iconruhepaiwukou-xuan",
			"image": 'images/map/rhpwk.png',
			"count": "12",
			"unit": "个",
			"type": "pointVector",
			"active": "color4",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"data": null,
			"visible": false,
			"click": true,
			"info": {
				"title": "入河排污口",
				"field": {
					"name": {
						"name": "名称",
						"type": "string"
					},
					"position": {
						"name": "位置",
						"type": "string"
					},
					"pollute": {
						"name": "污染物",
						"type": "string"
					},
					"factory": {
						"name": "污水处理工厂",
						"type": "string"
					},
					"setUnit": {
						"name": "负责单位",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "水域岸线",
			"name": "water_SYAX",
			"icon": "iconshuiyuanxian-xuan",
			"image": 'images/map/syax.png',
			"count": "12",
			"unit": "条",
			"active": "color5",
			"type": "wms",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"click": true,
			"visible": false,
			"info": {
				"title": "HHMC",
				"field": {
					"HDMC": {
						"name": "河段名称",
						"type": "string"
					},
					"HHMC": {
						"name": "河湖名称",
						"type": "string"
					},
					"LXMC": {
						"name": "类型",
						"type": "string"
					},
					"Area": {
						"name": "面积（km²）",
						"type": "number"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "采砂管理",
			"name": "cs",
			"icon": "iconcaishaguanli-xuan",
			"image": 'images/map/csgl.png',
			"count": "8",
			"unit": "处",
			"active": "color6",
			"type": "wms",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"visible": false,
			"click": true,
			"info": {
				"title": "name",
				"field": {
					"name": {
						"name": "可采区名称",
						"type": "string"
					},
					"wz": {
						"name": "可采区位置",
						"type": "string"
					},
					"mj": {
						"name": "可采区 面积(km²)",
						"type": "number"
					},
					"fw": {
						"name": "可采区范围(长x宽m)",
						"type": "string"
					},
					"cszl": {
						"name": "可利用采砂总量(10t)",
						"type": "number"
					},
					"kzcszl": {
						"name": "年度控制采砂总量(10t)",
						"type": "number"
					},
					"sd": {
						"name": "平均开采深度(m)",
						"type": "number"
					},
					"gd": {
						"name": "控制开采高(黄海m)",
						"type": "number"
					},
					"csfs": {
						"name": "开采方式",
						"type": "string"
					},
					"jq": {
						"name": "挖掘机(台)",
						"type": "number"
					},
					"cgl": {
						"name": "可利用层构料",
						"type": "string"
					},
					"time": {
						"name": "采砂时间",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "水利工程",
			"name": "waterProject",
			"icon": "iconshuiligongcheng-xuan",
			"image": 'images/map/slgc.png',
			"count": "12",
			"unit": "处",
			"active": "color7",
			"type": "pointVector",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"visible": false,
			"click": true,
			"info": {
				"title": "水利工程",
				"field": {
					"projectName": {
						"name": "项目名称",
						"type": "string"
					},
					"buildLocal": {
						"name": "建设地点名称",
						"type": "string"
					},
					"riverName": {
						"name": "所在河流",
						"type": "string"
					},
					"content": {
						"name": "建设内容",
						"type": "string"
					},
					"orgName": {
						"name": "工程主管部门",
						"type": "string"
					},
					"fxTechMan": {
						"name": "防汛技术责任人",
						"type": "string"
					},
					"fxAdminMan": {
						"name": "防汛行政责任人",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "水环境监测",
			"name": "envMonitorPoin",
			"icon": "iconshuihuanjingjiance-xuan",
			"image": 'images/map/shjjcd.png',
			"count": "10",
			"unit": "个",
			"type": "pointVector",
			"active": "color8",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"data": null,
			"visible": false,
			"click": true,
			"info": {
				"title": "水环境监测点",
				"field": {
					"name": {
						"name": "站名",
						"type": "string"
					},
					"stationAddress": {
						"name": "地址",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "水库信息",
			"name": "reservoirInfo",
			"icon": "iconshuikuxinxi-xuan",
			"image": 'images/map/skxx.png',
			"count": "31",
			"unit": "座",
			"type": "pointVector",
			"active": "color9",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"data": null,
			"visible": false,
			"click": true,
			"info": {
				"title": "水库信息",
				"field": {
					"name": {
						"name": "名称",
						"type": "string"
					},
					"storage": {
						"name": "总库容（万m³）",
						"type": "string"
					},
					"area": {
						"name": "面积(km²)",
						"type": "string"
					},
					"location": {
						"name": "所在位置",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "污染企业",
			"name": "polluteEnterprises",
			"icon": "iconwuranqiye-xuan",
			"image": 'images/map/wrqyfb.png',
			"count": "20",
			"unit": "家",
			"type": "pointVector",
			"active": "color10",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"data": null,
			"visible": false,
			"click": true,
			"info": {
				"title": "污染企业",
				"field": {
					"name": {
						"name": "名称",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "养殖企业",
			"name": "breedEnterprises",
			"icon": "iconyangzhiqiye-xuan",
			"image": 'images/map/yzqyfb.png',
			"count": "12",
			"unit": "家",
			"type": "pointVector",
			"active": "color11",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"data": null,
			"visible": false,
			"click": true,
			"info": {
				"title": "养殖企业",
				"field": {
					"name": {
						"name": "名称",
						"type": "string"
					}
				}
			}
		},
		{
			"id": "0158336bce132v9282de583367510107",
			"alias": "地下管网",
			"name": "gw_line",
			"icon": "icondixiaguanwang-xuan",
			"image": 'images/map/dxgxfb.png',
			"count": "60",
			"unit": "条",
			"active": "color12",
			"type": "wms",
			"url": "",
			"IntranetUrl": "http://193.10.6.2:4521/geoserver/ja/wms",
			"click": true,
			"visible": false,
			"info": {
				"title": "Layer",
				"field": {
					"Layer": {
						"name": "管线类型",
						"type": "string"
					},
					"LineWt": {
						"name": "管线宽度（厘米）",
						"type": "string"
					}
				}
			}
		}
	]
}
