const IMAGELENGTH = 160;
/**
 * 根据水位值获取对应的颜色值
 * @param {Object} value
 */
function getRiverColor(riverType, value) {
	if (riverType == "A") { //河流
		if (value < 15) {
			return '#0DE09E';
		} else if (value >= 15 && value < 18) { //防洪限制水位
			return '#ffc700';
		} else if (value >= 18 && value < 20) { //警戒水位
			return '#ff9900';
		} else if (value >= 20) { //保证水位
			return '#ff0000';
		}
	} else if (riverType == "B") { //湖库
		if (value < 70) {
			return '#0DE09E';
		} else if (value >= 70 && value < 75) { //防洪限制水位
			return '#ffc700';
		} else if (value >= 75 && value < 79) { //警戒水位
			return '#ff9900';
		} else if (value >= 79) { //保证水位
			return '#ff0000';
		}
	}
	return '#0DE09E';
}

/**
 * 根据降水量值获取对应的颜色值
 * @param {Object} value
 */
function getColor(value) {
	if (value > 10 && value <= 20) { //蓝色预警
		return '#0DE09E';
	} else if (value > 20 && value <= 30) { //黄色预警
		return '#ffc700';
	} else if (value > 30 && value <= 50) { //橙色预警
		return '#ff9900';
	} else if (value > 50) { //红色预警
		return '#ff0000';
	}
}


/**
 *设置颜色值 
 * @param {Object} colorType
 */
function setColorValue(colorType) {
	if (colorType == "I类") {
		return colorValue = "#c5ffff";
	} else if (colorType == "II类") {
		return colorValue = "#1fcaf9";
	} else if (colorType == "III类") {
		return colorValue = "#00ff00";
	} else if (colorType == "IV类") {
		return colorValue = "#ffff00";
	} else if (colorType == "V类") {
		return colorValue = "#ff9000";
	} else if (colorType == "劣V类") {
		return colorValue = "#ff0000";
	}
	return colorValue = "#c5ffff";
}

/**
 * 根据运行状态获取对应的颜色值
 * @param {Object} value
 */
function getStateColor(value) {
	alert(value)
	if (value == "正常") { //正常
		return '#55E5FF';
	} else { //异常
		return '#FFD800';
	}
}


/**
 * 文本框根据输入内容自适应高度
 * @param                {HTMLElement}        输入框元素
 * @param                {Number}                设置光标与输入框保持的距离(默认0)
 * @param                {Number}                设置最大高度(可选)
 */
var autoTextarea = function(elem, extra, maxHeight) {
	extra = extra || 0;
	var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
		isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
		addEvent = function(type, callback) {
			elem.addEventListener ?
				elem.addEventListener(type, callback, false) :
				elem.attachEvent('on' + type, callback);
		},
		getStyle = elem.currentStyle ? function(name) {
			var val = elem.currentStyle[name];

			if (name === 'height' && val.search(/px/i) !== 1) {
				var rect = elem.getBoundingClientRect();
				return rect.bottom - rect.top -
					parseFloat(getStyle('paddingTop')) -
					parseFloat(getStyle('paddingBottom')) + 'px';
			};

			return val;
		} : function(name) {
			return getComputedStyle(elem, null)[name];
		},
		minHeight = parseFloat(getStyle('height'));

	elem.style.resize = 'none';

	var change = function() {
		var scrollTop, height,
			padding = 0,
			style = elem.style;

		if (elem._length === elem.value.length) return;
		elem._length = elem.value.length;

		if (!isFirefox && !isOpera) {
			padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
		};
		scrollTop = document.body.scrollTop || document.documentElement.scrollTop;

		elem.style.height = minHeight + 'px';
		if (elem.scrollHeight > minHeight) {
			if (maxHeight && elem.scrollHeight > maxHeight) {
				height = maxHeight - padding;
				style.overflowY = 'auto';
			} else {
				height = elem.scrollHeight - padding;
				style.overflowY = 'hidden';
			};
			style.height = height + extra + 'px';
			scrollTop += parseInt(style.height) - elem.currHeight;
			document.body.scrollTop = scrollTop;
			document.documentElement.scrollTop = scrollTop;
			elem.currHeight = parseInt(style.height);
		};
	};

	addEvent('propertychange', change);
	addEvent('input', change);
	addEvent('focus', change);
	change();
};

/*
 *时间相减
 */
function timeFnS(dateBegin, dateEnd) {
	if (dateBegin) {
		const end = dateEnd || new Date();
		var dateDiff = end.getTime() - dateBegin.getTime(); //时间差的毫秒数
		var dayDiff = Math.floor(dateDiff / (24 * 3600 * 1000)); //计算出相差天数

		var leave1 = dateDiff % (24 * 3600 * 1000); //计算天数后剩余的毫秒数
		var hours = Math.floor(leave1 / (3600 * 1000)); //计算出小时数

		var leave2 = leave1 % (3600 * 1000); //计算小时数后剩余的毫秒数
		var minutes = Math.floor(leave2 / (60 * 1000)); //计算相差分钟数

		var time = "";
		if (dayDiff != 0) {
			time += dayDiff + "天";
		}
		if (hours != 0) {
			time += hours + "小时";
		}
		if (minutes != 0) {
			time += minutes + "分钟";
		}
		if (time === "") {
			time += "1分钟";
		}
		return {
			format: time,
			sec: dateDiff / 1000
		};
	}
}

/*
 *时间相减
 */
function timeFn(dateBegin, dateEnd) {
	if (dateBegin) {
		const end = dateEnd || new Date();
		var dateDiff = end.getTime() - dateBegin.getTime(); //时间差的毫秒数
		var dayDiff = Math.floor(dateDiff / (24 * 3600 * 1000)); //计算出相差天数

		var leave1 = dateDiff % (24 * 3600 * 1000); //计算天数后剩余的毫秒数
		var hours = Math.floor(leave1 / (3600 * 1000)); //计算出小时数

		var leave2 = leave1 % (3600 * 1000); //计算小时数后剩余的毫秒数
		var minutes = Math.floor(leave2 / (60 * 1000)); //计算相差分钟数

		var time = "";
		if (dayDiff != 0) {
			time += dayDiff + "天";
		}
		if (hours != 0) {
			time += hours + "小时";
		}
		if (minutes != 0) {
			time += minutes + "分钟";
		}
		if (time === "") {
			time += "1分钟";
		}
		return time;
	}
}

// 日期格式化
function show_cur_times(date) {
	//获取当前日期
	var date_time = date || new Date();
	//年
	var year = date_time.getFullYear();
	//判断小于10，前面补0
	if (year < 10) {
		year = "0" + year;
	}

	//月
	var month = date_time.getMonth() + 1;
	//判断小于10，前面补0
	if (month < 10) {
		month = "0" + month;
	}

	//日
	var day = date_time.getDate();
	//判断小于10，前面补0
	if (day < 10) {
		day = "0" + day;
	}

	//时
	var hours = date_time.getHours();
	//判断小于10，前面补0
	if (hours < 10) {
		hours = "0" + hours;
	}

	//分
	var minutes = date_time.getMinutes();
	//判断小于10，前面补0
	if (minutes < 10) {
		minutes = "0" + minutes;
	}

	//秒
	var seconds = date_time.getSeconds();
	//判断小于10，前面补0
	if (seconds < 10) {
		seconds = "0" + seconds;
	}

	//拼接年月日时分秒
	var date_str = year + "年" + month + "月" + day + "日 " + hours + ":" + minutes + ":" + seconds;

	//显示在id为showtimes的容器里
	return date_str
}

function timeToMinutes(dateBegin, dateEnd) {
	if (dateBegin != null) {
		var dateDiff = dateEnd.getTime() - dateBegin.getTime(); //时间差的毫秒数
		var minutes = Math.floor(dateDiff / (60 * 1000)); //计算相差分钟数
		return minutes;
	}
}

Date.prototype.format = function(format) {
	var o = {
		"M+": this.getMonth() + 1, //month
		"d+": this.getDate(), //day
		"h+": this.getHours(), //hour
		"m+": this.getMinutes(), //minute
		"s+": this.getSeconds(), //second
		"q+": Math.floor((this.getMonth() + 3) / 3), //quarter
		"S": this.getMilliseconds() //millisecond
	}
	if (/(y+)/.test(format)) format = format.replace(RegExp.$1,
		(this.getFullYear() + "").substr(4 - RegExp.$1.length));
	for (var k in o)
		if (new RegExp("(" + k + ")").test(format))
			format = format.replace(RegExp.$1,
				RegExp.$1.length == 1 ? o[k] :
				("00" + o[k]).substr(("" + o[k]).length));
	return format;
}

Date.prototype.lastMonth = function() {
	const date = new Date();
	const y = date.getFullYear() - 1;
	const m = date.getMonth(); // 月份
	const d = date.getDate(); // 日
	return new Date(y, m, d).format('yyyy-MM-dd');
}

/**
 * @description  自定义时间
 * @param {Number}  year 当前年减去几年
 * @param {Number}  month 当前月减去几月
 * @param {Number}  day 当前天减去几天
 * @param {String}  format 格式化 default: yyyy-MM-dd
 * @param {Boolean}  coverDay 是否指定当前天数
 * @param {Boolean}  coverMonth 是否指定当前天数
 * @param {Boolean}  coverYear 是否指定当前天数
 * @return {Date} date format处理过的时间格式
 */
Date.prototype.customDate = function({
	year,
	month,
	day,
	format,
	coverDay,
	coverMonth,
	coverYear
}) {
	const date = new Date();
	const y = coverYear ? year : date.getFullYear() - (year || 0);
	const m = coverMonth ? month : date.getMonth() - (month || 0); // 月份
	const d = coverDay ? day : date.getDate() - (day || 0); // 日
	return new Date(y, m, d).format(format || 'yyyy-MM-dd');
}

/**
 * @description 上传照片 拍照 相册选择 需继承在plus环境下
 * @param {Object} payload 自定义 可更改 一般用于从相册选择的配置项
 */
function uploadPictures(payload) {
	return new Promise(function(resolve, reject) {
		var bts = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];
		plus.nativeUI.actionSheet({
				title: "上传照片",
				cancel: "取消",
				buttons: bts
			},
			function(e) {
				var id = e.index - 1;
				switch (id) {
					case 0: //拍照
						_getImage().then((res) => {
							resolve(res)
							console.log('拍照' + JSON.stringify(res))
						}).catch((err) => {
							reject(err)
							console.log('拍照失败' + err)
						});
						break;
					case 1: //从相册选择
						_galleryImgsSelected(payload).then((res) => {
							resolve(res)
							console.log('相册' + JSON.stringify(res))
						}).catch((err) => {
							reject(err)
							console.log('拍照失败' + err)
						});
						break;
				}
			}
		);
	});
}

/**
 * @description 拍照 及 录像
 * @param {Object} payload 自定义 可更改 一般用于从相册选择的配置项
 */
function uploadTakeAndVideo() {
	return new Promise(function(resolve, reject) {
		var bts = [{
			title: "拍照"
		}, {
			title: "录像"
		}];
		plus.nativeUI.actionSheet({
				title: "上传",
				cancel: "取消",
				buttons: bts
			},
			function(e) {
				var id = e.index - 1;
				switch (id) {
					case 0: //拍照
						_getImage().then((res) => {
							resolve(res)
						}).catch((err) => {
							reject(err)
							console.log('拍照失败' + err)
						});
						break;
					case 1: //录像
						console.log('视频')
						_videoCapture().then((res) => {
							// video 表示是视频文件
							resolve({
								...res,
								video: true
							})
						}).catch((err) => {
							reject(err)
							console.log('录像失败' + err)
						});
						break;
				}
			}
		);
	});
}


/**
 * @description 录像 及 相册选择录像
 */
function uploadPhotoAndVideo() {
	return new Promise(function(resolve, reject) {
		var bts = [{
			title: "录像"
		}, {
			title: "从手机相册中选择"
		}];
		plus.nativeUI.actionSheet({
				title: "上传",
				cancel: "取消",
				buttons: bts
			},
			function(e) {
				var id = e.index - 1;
				switch (id) {
					case 0:
						//录像
						_videoCapture().then((res) => {
							// video 表示是视频文件
							resolve(res)
						}).catch((err) => {
							reject(err)
							console.log('录像失败' + err)
						});
						break;
					case 1:
						_galleryVideo().then((res) => {
							resolve(res)
						}).catch((err) => {
							reject(err)
							console.log('相册选择失败' + err)
						});
						break;
				}
			}
		);
	});
}
/**
 *拍照并保存照片到系统相册 
 */
function _getImage() {
	const flieList = [];
	var cmr = plus.camera.getCamera();
	return new Promise(function(resolve, reject) {
		cmr.captureImage(function(path) {
			plus.io.resolveLocalFileSystemURL(path, function(entry) {
				var s = entry.toLocalURL() + "?version=" + new Date().getTime();
				var name = path.substr(path.lastIndexOf('/') + 1);
				plus.zip.compressImage({
					src: path,
					dst: '_doc/' + name,
					overwrite: true,
					quality: 70, //质量1-100
					width: "100%", //缩小到原来的一半
					height: "100%" //缩小到原来的一半
				}, function(zip) {
					var sizes = zip.size;
					// if (sizes > (2 * 1024 * 1024)) {
					// 	return mui.toast('文件超大,请重新选择~');
					// }
					flieList.push({
						...zip,
						name: name,
						id: name + new Date().getTime(),
						path: zip.target,
					})
					//保存到相册
					// plus.gallery.save(path, function() {
					// 	//					uploadPhotos(path);
					// }, function(e) {
					// 	console.log('保存失败: ' + JSON.stringify(e));
					// });
					// 成功
					resolve(flieList)
				}, function(zipe) {
					// 失败
					reject(zipe)
					mui.toast('压缩失败！')
				});
			}, function(e) {
				// 失败
				reject(e.message)
				console.log("读取拍照文件错误：" + e.message);
			});
			//保存到相册
			//				plus.gallery.save(path, function() {
			//					//					uploadPhotos(path);
			//				}, function(e) {
			//					console.log('保存失败: ' + JSON.stringify(e));
			//				});
		}, function(e) {
			mui.toast('取消拍照');
		}, {
			filename: '_doc/gallery/',
			index: 1
		});
	})
}


/**
 *从相册中选择多张图片(限定最多选择8张) 
 */
function _galleryImgsSelected(payload = {}) {
	// 从相册中选择图片
	return new Promise(function(resolve, reject) {
		const fileList = []
		plus.gallery.pick(function(path) {
			// 多选的时候结构是 { files: [] }
			if (Object.prototype.toString.call(path) === '[object Object]') {
				// 错误的开关
				let err_B = true;
				const {
					files
				} = path;
				files.forEach((item, index) => {
					// 上传失败
					if (!err_B) {
						console.log('失败')
						reject('上传失败')
						return;
					}
					const fileName = item.substr(item.lastIndexOf('/') + 1);
					plus.zip.compressImage({
						//src: e.files[i],
						src: item,
						dst: '_doc/' + fileName,
						overwrite: true,
						quality: 70, //质量1-100
						width: "100%", //缩小到原来的一半
						height: "100%" //缩小到原来的一半
					}, function(zip) {
						var sizes = zip.size;
						// if (sizes > (2 * 1024 * 1024)) {
						// 	err_B = false
						// 	return mui.toast('文件超大,请重新选择~');
						// }
						// 成功
						fileList.push({
							...zip,
							name: fileName,
							id: fileName + '_' + new Date().getTime(),
							path: zip.target,
						})
						// 成功
						if (index === files.length - 1) resolve(fileList);
					}, function(zipe) {
						err_B = false;
						// 失败
						mui.toast('压缩失败！')
					});

				})
			} else {
				const fileName = path.substr(path.lastIndexOf('/') + 1);
				plus.zip.compressImage({
					//src: e.files[i],
					src: path,
					dst: '_doc/' + fileName,
					overwrite: true,
					quality: 70, //质量1-100
					width: "50%", //缩小到原来的一半
					height: "50%" //缩小到原来的一半
				}, function(zip) {
					var sizes = zip.size;
					if (sizes > (2 * 1024 * 1024)) {
						reject(zipe)
						return mui.toast('文件超大,请重新选择~');
					}
					// 成功
					fileList.push({
						...zip,
						name: fileName,
						id: fileName + '_' + new Date().getTime(),
						path: zip.target,
					})
					resolve(fileList)
				}, function(zipe) {
					reject(zipe)
					// 失败
					mui.toast('压缩失败！')
				});
			}
		}, function(e) {
			mui.toast('取消选择图片');
		}, {
			filter: 'image',
			multiple: payload.multiple || false,
			maximum: payload.max || 4,
			//selected: mPotosFiles,
			system: payload.system || false,
			onmaxed: function() {
				plus.nativeUI.alert(`最多只能选择${payload.max || 4}张图片`);
			}
		});
	})
}


/**
 * @description 调用摄像头进行摄像操作
 * @example cam.startVideoCapture(successCB, errorCB, options);
 * @param {successCB}  拍照操作成功的回调函数
 * @param {errorCB}  拍照操作失败的回调函数
 * @param {options}  摄像头拍照参数
 */
function _videoCapture() {
	var cmr = plus.camera.getCamera();
	var res = cmr.supportedVideoResolutions[0];
	var fmt = cmr.supportedVideoFormats[0];
	console.log("Resolution: " + res + ", Format: " + fmt);

	return new Promise((resolve, reject) => {
		// 开始录像
		cmr.startVideoCapture(function(t) {
			// 成功之后 转化为本地路径
			plus.io.resolveLocalFileSystemURL(t, function(entry) {
				const videofile = entry.toLocalURL();
				resolve({
					id: new Date().getTime(),
					path: videofile
				})
			})
			//t 摄像操作保存的文件路径
		}, function(e) {
			console.log(JSON.stringify(e))
			reject(e)
		}, {
			filename: '_downloads/video/', //录像文件保存的路径
			format: cmr.supportedVideoFormats[0], //摄像的文件格式
			index: 1, //摄像默认使用的摄像头
			videoMaximumDuration: 15, //视频长度
			resolution: cmr.supportedVideoResolutions[0], //摄像使用的分辨率
			popover: { //摄像界面弹出指定区域
				top: "10px",
				left: "10px",
				width: "200px",
				height: "200px"
			}
		})
	})
}


/**
 * @description  从相册选择录像
 */
function _galleryVideo() {
	return new Promise((resolve, reject) => {
		// 从相册中选择图片
		plus.gallery.pick(function(e) { //打开相册后，回调的文件路径e
			resolve({
				id: new Date().getTime(),
				path: e
			})
		}, function(e) {
			mui.toast("您取消了选择录像");
			reject();
		}, {
			filter: "video", //只打开视频，但是不知道为什么有其他选项
			system: false //不用系统自带的打开相册功能
		});
	})
}

/**
 * @description 删除文件
 */
function _removeFile(url) {

	_removeApkFile();

	plus.io.resolveLocalFileSystemURL(url, function(entry) {
		if (url[url.length - 1] === '/') {
			// 递归删除目录
			entry.removeRecursively(function(entry) {
				console.log('删除成功')
			}, function(e) {
				console.log(e.message)
			});
		} else {
			entry.remove(); //删除单个文件 _downloads/改文件名
		}
	});
}

/**
 * @description 删除文件
 */
function _removeApkFile() {

	plus.io.resolveLocalFileSystemURL('_downloads/', function(entry) {
		const directoryReader = entry.createReader();

		directoryReader.readEntries(
			function(entries) { //历遍子目录即可
				for (var i = 0; i < entries.length; i++) {
					const name = entries[i].name;
					const [t, a] = name.split('.')
					if (a === 'apk' && t.startsWith('jax')) {
						entries[i].remove(); //这是删除指定的文件
						console.log("删除文件信息：" + entries[i].name);
					}
				}
			},
			function(err) {
				console.log("访问目录失败");
			});
	});
}


/**
 * @description 播放视频
 * @param {String} url 视频地址
 * @param {Boolean} isLocal  'local' 本地 'noLocal' 外网 是否是本地路径
 */

function _openVideo(url, isLocal) {
	console.log(isLocal)
	if (isLocal === 'local') {
		console.log('本地')
		plus.runtime.openFile(url)
	} else {
		console.log(url)
		var Intent = plus.android.importClass("android.content.Intent");
		var Uri = plus.android.importClass("android.net.Uri");
		var main = plus.android.runtimeMainActivity();
		var intent = new Intent(Intent.ACTION_VIEW);
		var uri = Uri.parse(url);
		intent.setDataAndType(uri, "video/*");
		main.startActivity(intent);
	}
}

/**
 * @description  创建一个新的webview窗口 打开视频
 * @param {Object} file 视频url
 */

function _openVideoWebView(file) {
	/**
	 * @description 创建VideoPlayer对象
	 * @example VideoPlayer plus.video.createVideoPlayer(id, styles);
	 * @param {id}  VideoPlayer对象的全局标识
	 * @param {styles}  视频播放控件参数
	 */
	var player = plus.video.createVideoPlayer('vp', {
		'src': file, //视频资源地址,支持本地地址,也支持网络地址及直播流
		'initial-time': 0, //视频初始播放位置,单位为秒,仅在视频开始播放前设置有效
		// 'duration': 10,//视频长度,单位为秒,仅在视频开始播放前设置有效
		'controls': true, //是否显示默认播放控件
		'danmu-list': [],
		'show-mute-btn': true, // 是否显示静音按钮
		'danmu-btn': false, //是否显示弹幕按钮
		'enable-danmu': false, //是否展开弹幕
		'autoplay': true, //是否自动播放
		'loop': false, //是否循环播放
		'muted': false, //是否静音播放
		'direction': 0, //设置全屏时视频的方向
		'show-progress': true, //是否显示播放进度
		'show-fullscreen-btn': true, //是否显示全屏按钮
		'show-play-btn': true, //是否显示视频底部控制栏的播放按钮
		'show-center-play-btn': true, //是否显示视频中间的播放按钮
		'enable-progress-gesture': true, //是否开启控制进度的手势
		'objectFit': "fill", //当视频大小与video容器大小不一致时,视频的表现形式contain(包含),fill(填充),cover(覆盖),默认值为contain.
		'poster': '', //视频封面的图片网络资源地址
		'top': '0', //VideoPlayer控件左上角的垂直偏移量
		'left': '0', //VideoPlayer控件左上角的水平偏移量
		'width': '100%', //VideoPlayer控件的宽度
		'height': '100%', //VideoPlayer控件的高度
		'position': 'absolute' //VideoPlayer控件在Webview窗口的布局模式,static静态布局模式;absolute绝对布局模式,默认static
	});
	//创建VideoPlayer后,需要调用Webview窗口的append方法将其添加到Webview窗口后才能显示.
	plus.webview.currentWebview().append(player);
	return player;
}


/**
 * @description  获取图视频第一帧
 * @param {String} url 视频地址
 * @param {Function} callback 回调函数
 */
function setVideoList(url, callback) {
	// 取出第一帧图片
	// 在缓存中创建video标签
	var video = document.createElement("video")
	// 通过setAttribute给video dom元素添加自动播放的属性，因为视频播放才        
	// 能获取封面图
	video.setAttribute('autoplay', 'autoplay')
	// 再添加一个静音的属性，否则自动播放会有声音
	video.setAttribute('muted', 'muted')
	// video.setAttribute("crossOrigin",'anonymous') 
	video.setAttribute('crossOrigin', 'Anonymous')
	// 上面我们只是创建了video标签，视频播放需要内部的source的标签，scr为 
	// 播放源
	video.innerHTML = '<source src=' + url + ' type="audio/mp4">'
	// document.body.appendChild(video)
	// 再创建canvas画布标签
	var canvas = document.createElement('canvas');
	var ctx = canvas.getContext('2d');
	// video注册canplay自动播放事件
	video.addEventListener('loadeddata', function() {
		// 创建画布的宽高属性节点，就是图片的大小，单位PX
		var anw = document.createAttribute("width");
		anw.nodeValue = 500;
		var anh = document.createAttribute("height");
		anh.nodeValue = 300;
		canvas.setAttributeNode(anw);
		canvas.setAttributeNode(anh);
		// 画布渲染
		ctx.drawImage(video, 0, 0, 500, 300);
		// 生成图片
		const baseUrl = canvas.toDataURL('image/png') // 这就是封面图片的base64编码
		callback && callback(baseUrl);
		// 视频结束播放的事件
		video.pause();
		// 删除
		$(video).remove();
	}, false)
}
/**
 * @description 本地图片转为file文件
 * @param {Object} feedbackFiles 上传过图片的数组
 */
function _getfiles(feedbackFiles) {
	imagefiles = [];
	return new Promise(function(resolve, reject) {
		if (feedbackFiles.length > 0) {
			for (var i = 0; i < feedbackFiles.length; i++) {
				var fileP = feedbackFiles[i].path;
				// 将网络路径转为本地的路径，再将本地的路径转为file
				plus.io.resolveLocalFileSystemURL(plus.io.convertLocalFileSystemURL(fileP), function(
					entry) {
					// 可通过entry对象操作文件
					entry.file(function(file) {
						console.log('转化文件' + JSON.stringify(file));
						imagefiles.push(file);
						resolve(imagefiles);
					});
				}, function(e) {
					alert("Resolve file URL failed: " + e.message);
				});
			}
		}
	})
}


/**
 * @description  判断安卓手机是否有权限访问位置信息
 */
function AuthorizedLocation() {
	return new Promise((resole, reject) => {
		if (mui.os.ios || (mui.os.android && parseFloat(mui.os.version) > 4.4)) { //判断平台
			var context = plus.android.importClass("android.content.Context")
			var locationManager = plus.android.importClass("android.location.LocationManager")
			var main = plus.android.runtimeMainActivity()
			// 这一步是检测手机定位权限
			var mainSvr = main.getSystemService(context.LOCATION_SERVICE)
			var androidIsOpen = mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER)

			// 如果手机没有开始GPS 触发失败函数
			if (!androidIsOpen) {
				mui.toast('请开启手机GPS')
			}
			// 这一步是检测app的权限是否开启
			plus.android.requestPermissions(['android.permission.ACCESS_FINE_LOCATION'], function(e) {
				console.log('权限内容' + JSON.stringify(e))
				if (e.deniedAlways.length > 0) {
					//权限被永久拒绝
					plus.nativeUI.confirm("检测到没有开启定位权限，是否开启。", function(e) {
						if (e.index === 0) {
							// 包名
							var packageName = "plus.H5C4A1F5E";
							var main = plus.android.runtimeMainActivity();
							var Uri = plus.android.importClass("android.net.Uri");
							var Settings = plus.android.importClass(
								"android.provider.Settings");
							var packageURI = Uri.parse("package:" + packageName);
							var intent = plus.android.newObject("android.content.Intent",
								Settings.ACTION_APPLICATION_DETAILS_SETTINGS, packageURI);
							main.startActivity(intent);
						} else {
							mui.toast('已取消授权')
						}
					});
					// 弹出提示框解释为何需要定位权限，引导用户打开设置页面开启
					console.log('永久禁止' + e.deniedAlways.toString());
					reject();
				}
				if (e.deniedPresent.length > 0) { //权限被临时拒绝
					// 弹出提示框解释为何需要定位权限，可再次调用plus.android.requestPermissions申请权限
					plus.android.requestPermissions(['android.permission.ACCESS_FINE_LOCATION']);
					console.log('临时拒绝' + e.deniedAlways.toString());
					reject();
				}
				if (e.granted.length > 0) { //权限被允许
					//调用依赖获取定位权限的代码
					// mui.toast('定位功能已启动')
					resole();
				}
			}, function(e) {
				reject();
				console.log('错误33333' + JSON.stringify(e));
			});
		}
	})
}

/**
 * @param {Object} key
 * @param {Object} show 是否立即打开
 */
function isOpenSetting(key, show) {
	const callback = () => {
		var packageName = "plus.H5C4A1F5E";
		var main = plus.android.runtimeMainActivity();
		var Uri = plus.android.importClass("android.net.Uri");
		var Settings = plus.android.importClass(
			"android.provider.Settings");
		var packageURI = Uri.parse("package:" + packageName);
		var intent = plus.android.newObject("android.content.Intent",
			Settings.ACTION_APPLICATION_DETAILS_SETTINGS, packageURI);
		main.startActivity(intent);
	}

	if (show) {
		callback();
	} else {
		if (!localStorage.getItem(key)) {
			const text = '温馨提示：为了您更好的巡河体验，建议您在设置中开启以下功能。\n1、设置app自启动\n2、关闭手机对于app的省电策略控制\n是否立即设置？'
			plus.nativeUI.confirm(text, function(e) {
				if (e.index === 0) {
					callback();
				} else {
					mui.toast('后续可以在我的-系统设置-权限设置进行设置')
				}
			}, '巡河设置');

			localStorage.setItem(key, 'true');
		}
	}
}


function isAuthorizedApp() {
	var Intent = plus.android.importClass('android.content.Intent');
	var Build = plus.android.importClass("android.os.Build");
	var packageName = "plus.H5C4A1F5E";
	var main = plus.android.runtimeMainActivity();
	var Uri = plus.android.importClass("android.net.Uri");
	var packageURI = Uri.parse("package:" + packageName);
	var Settings = plus.android.importClass("android.provider.Settings");
	var intent = plus.android.newObject("android.content.Intent",
		Settings.ACTION_APPLICATION_DETAILS_SETTINGS, packageURI);
	main.startActivity(intent);


}

/**
 * 图片按宽高比例进行自动缩放
 * @param ImgObj
 *     缩放图片源对象
 * @param maxWidth
 *     允许缩放的最大宽度
 * @param maxHeight
 *     允许缩放的最大高度
 * @usage 
 *     调用：<img src="图片" οnlοad="DrawImage(this,100,100)">
 */
function DrawImage(ImgObj, maxWidth, maxHeight) {
	var image = new Image();
	//原图片原始地址（用于获取原图片的真实宽高，当<img>标签指定了宽、高时不受影响）
	image.src = ImgObj.src;
	// 用于设定图片的宽度和高度
	var tempWidth;
	var tempHeight;
	// if (image.complete)
	console.log(ImgObj.complete)

	if (image.width > 0 && image.height > 0) {
		//原图片宽高比例 大于 指定的宽高比例，这就说明了原图片的宽度必然 > 高度
		if (image.width / image.height >= maxWidth / maxHeight) {
			if (image.width > maxWidth) {
				tempWidth = maxWidth;
				// 按原图片的比例进行缩放
				tempHeight = (image.height * maxWidth) / image.width;
			} else {
				// 按原图片的大小进行缩放
				tempWidth = image.width;
				tempHeight = image.height;
			}
		} else { // 原图片的高度必然 > 宽度
			if (image.height > maxHeight) {
				tempHeight = maxHeight;
				// 按原图片的比例进行缩放
				tempWidth = (image.width * maxHeight) / image.height;
			} else {
				// 按原图片的大小进行缩放
				tempWidth = image.width;
				tempHeight = image.height;
			}
		}
		// 设置页面图片的宽和高
		ImgObj.style.height = tempHeight + 'px';
		ImgObj.style.width = tempWidth + 'px';
		ImgObj.style.display = 'block';
		// 提示图片的原来大小
		ImgObj.alt = image.width + "×" + image.height;
	}
}

/**
 * @description  获取app当前版本号
 * @return {String} version
 */

function getVersion() {
	return new Promise((resolve, reject) => {
		if (plus) {
			plus.runtime.getProperty(plus.runtime.appid, function(inf) {
				resolve(inf.version)
			})
		} else {
			reject();
			console.log('没有在plus环境下')
		}
	})
}

/**
 * @description 复制文本
 * @param {*} text 
 */
function copyText(text) {
	if (!plus) return;
	if (mui.os.ios) { // ios 
		var UIPasteboard = plus.ios.importClass("UIPasteboard");
		var generalPasteboard = UIPasteboard.generalPasteboard();
		generalPasteboard.plusCallMethod({
			setValue: text,
			forPasteboardType: "public.utf8-plain-text"
		});
		generalPasteboard.plusCallMethod({
			valueForPasteboardType: "public.utf8-plain-text"
		});
		mui.toast('复制成功')
	} else { //安卓
		var context = plus.android.importClass("android.content.Context");
		var main = plus.android.runtimeMainActivity();
		var clip = main.getSystemService(context.CLIPBOARD_SERVICE);
		plus.android.invoke(clip, "setText", text);
		mui.toast('复制成功')
	}
}


/**
 * @description 判断应用是否安装
 */
function isIstall(packageName) {
	try {
		var main = plus.android.runtimeMainActivity();
		var packageManager = main.getPackageManager();
		var PackageManager = plus.android.importClass(packageManager);
		var packageinfo = packageManager.getPackageInfo(packageName, PackageManager.GET_ACTIVITIES)
		if (packageinfo) {
			return true;
		} else {
			return false;
		}
	} catch (e) {
		return false;
	}
}

function filterMapByApk(location) {
	const appId = plus.runtime.appid;
	// 腾讯地图 "qqmap://map/routeplan?type=drive&fromcoord=CurrentLocation&tocoord="+coordQQ[1]+","+coordQQ[0]+"&referer=OB4BZ-D4W3U-B7VVO-4PJWW-6TKDJ-WPB77"
	const btnList = [{
		title: '高德地图',
		// url: `androidamap://navi?sourceApplication=${appId}&lat=${location[1]}&lon=${location[0]}&dev=1`,
		url: `amapuri://route/plan/?dlat=${location[1]}&dlon=${location[0]}&dev=1&t=0`,
		// amapuri://route/plan/?dlat=39.98848272&dlon=116.47560823&dev=1&t=0
		pack: 'com.autonavi.minimap'
	}]

	const list = btnList.filter((item) => isIstall(item.pack));

	if (list.length) {
		plus.nativeUI.actionSheet({
			title: "请选择地图",
			cancel: "取消",
			buttons: list
		}, function(e) {
			if (e.index > 0) {
				plus.runtime.openURL(list[e.index - 1].url);
			}
		});
	} else {
		mui.toast('此功能只能使用高德地图，请前往应用市场下载');
	}
	console.log(JSON.stringify(list));
}

/**
 * @description 打开二维码
 */
function openQrcode() {
	// plus.nativeUI.previewImage([
	// 	`${app.getURL()}/img/qrCode/qrCode.png?time=${new Date().getTime()}`
	// ]);
	displayLargeImage([
		`${app.getURL()}/img/qrCode/qrCode.png?time=${new Date().getTime()}`
	])
}

function displayLargeImage(ig, i, options = {}) {
	const {
		btnConfig = []
	} = options;

	// if (PhotoSwipe) {
	// 	const option = {
	// 		dataSource: [],
	// 		spacing: 0.5,
	// 		pswpModule: PhotoSwipe,
	// 		wheelToZoom: true,
	// 		arrowPrev: false,
	// 		arrowNext: false,
	// 		zoom: true,
	// 		close: true,
	// 		counter: true,
	// 		clickToCloseNonZoomable: true,
	// 	};

	// 	const callback = () => {
	// 		plus.nativeUI.closeWaiting();
	// 		const lightbox = new PhotoSwipeLightbox(option);
	// 		lightbox.init();
	// 		lightbox.loadAndOpen(i);
	// 		// const pswp = lightbox.pswp;
	// 	}

	// 	ig.forEach((item, index) => {
	// 		const image = new Image();
	// 		//原图片原始地址（用于获取原图片的真实宽高，当<img>标签指定了宽、高时不受影响）
	// 		image.src = item;

	// 		// 判断是否有缓存
	// 		if (image.complete) {
	// 			option.dataSource.push({
	// 				src: item,
	// 				width: image.width,
	// 				height: image.height
	// 			})


	// 			if (index === ig.length - 1) {
	// 				callback();
	// 			}
	// 		} else {
	// 			image.onload = function() {
	// 				option.dataSource.push({
	// 					src: item,
	// 					width: image.width,
	// 					height: image.height
	// 				});

	// 				if (index === ig.length - 1) {
	// 					callback();
	// 				}
	// 			}

	// 		}
	// 	})
	// }

	plus.nativeUI.previewImage(ig, {
		current: i || 0, //点击图片时显示图片的索引值    
		onLongPress: function(e) {
			console.log(JSON.stringify(e))
			var path = e.url;

			const bts = [{
				title: "保存到手机",
				callback: function() {
					plus.nativeUI.showWaiting('加载中');

					if (path.startsWith('http')) {
						const dtask = plus.downloader.createDownload(path, {}, function(d,
							status) {
							console.log(JSON.stringify(status))
							if (status == 200) {
								plus.gallery.save(d.filename, function() { //保存到相册方法
									plus.nativeUI.closeWaiting();
									mui.toast('已保存到手机相册');
								}, function() {
									plus.nativeUI.closeWaiting();
									mui.toast('保存失败，请重试！');
								});
							} else {
								// alert( "Download failed: " + status );
								mui.toast("下载失败");
							}
						});
						dtask.start();
					} else {
						plus.gallery.save(path,
							function() { //保存到相册方法
								plus.nativeUI.closeWaiting();
								mui.toast('已保存到手机相册');
							},
							function() {
								plus.nativeUI.closeWaiting();
								mui.toast('保存失败，请重试！');
							});
					}
				}
			}].concat(btnConfig);

			plus.nativeUI.actionSheet({
					title: "图片预览",
					cancel: "取消",
					buttons: [...bts]
				},
				function(f) {
					if (f.index > 0) {
						const i = f.index - 1;
						const {
							callback
						} = bts[i];
						console.log(JSON.stringify(e))
						callback && callback(e);
					}
				}
			);
		}
	})
}


/**
 * @description 根据高德地图获取地址
 * @param {Object} list
 */
function getAddress(list) {
	const geoArr = [];
	return new Promise((resolve, reject) => {
		AMap.plugin('AMap.Geocoder', function() {
			const geocoder = new AMap.Geocoder();
			list.forEach((item, index) => {
				geocoder.getAddress(item, (status, result) => {
					console.log(JSON.stringify(result));
					if (status === 'complete' && result.info === 'OK') {
						const {
							regeocode: {
								addressComponent: {
									province,
									city,
									district,
									township,
									street
								},
								formattedAddress
							}
						} = result;

						geoArr.push(formattedAddress);

						if (index === list.length - 1) {
							resolve(geoArr);
						}
						// result为对应的地理位置详细信息
					} else {
						geoArr.push('未知');

						if (index === list.length - 1) {
							resolve(geoArr);
						}
					}
				})
			});

		})
	})
}

function getBit(value, bit = 5) {
	let str = value.toString();
	let strIndex = str.indexOf('.');
	if (strIndex === -1) return str;
	str = str.substring(0, strIndex + bit + 1);
	return Number(str);
}

function createDownload(url =
	'http://223.82.56.105:11732/share/localDataSource/downloadApk?sourceId=d25f21dda9d4e3d06fac700892e06dfe') {
	if (!url) {
		mui.toast("获取下载路径错误");
		return;
	}
	//事件参数单位为s
	var downloadTask = plus.downloader.createDownload(url, {
		//timeout: 10,
		//retryInterval: 5,
		//retry: 3
	});
	plus.notification.setNotification("新版下载", "开始下载"); //插件调用
	downloadTask.start();
	console.log("$$$$$$");
	downloadTask.addEventListener("statechanged", function(task, status) {
		//console.log("task--->"+task);
		console.log("task.state--->" + task.state);
		//var current = parseInt(100 * task.downloadedSize / task.totalSize);
		//console.log("current-->" + current);
		//console.log("status--->"+status);
		switch (task.state) {
			case 1: // 开始
				console.log('开始');
				break;
			case 2: //已连接到服务器
				console.log('已连接到服务器');
				break;
			case 3: // 已接收到数据
				console.log('已接收到数据');
				var current = parseInt(100 * task.downloadedSize / task.totalSize);
				plus.notification.setProgress(current); //插件调用
				break;
			case 4: // 下载完成 
				console.log('下载完成 ');
				plus.notification.compProgressNotification("下载完成"); //插件调用
				plus.runtime.install(task.filename, {}, function() {
					//成功安装回调，执行重启app操作
					plus.runtime.restart();
				}, function(DOMException) {
					console.log(JSON.stringify(DOMException));
					mui.toast("安装失败");
					//alert("安装失败")
				});
				break;
		}
	});
}
