(function($, Modal) {
	const _proto = Modal.prototype;
	_proto.init = function (options) {
		this.options = options;
		this.$modal = $('<div class="jq-modal"></div>').hide();
		this.$content = $('<div class="jq-modal-content"></div>');
		this.$cBody = $('<div class="jq-modal-content-body"></div>');
		this._create();
	}
	
	_proto._create = function () {
		const _this = this;
		const { el, footer = true, header = true, title, onOk, okText } = this.options;
		this.$content.append(this.$cBody);
		if (el) {
			this.$el = $(el);
			this.$cBody.append(this.$el);
		}
		
		if (footer) {
			this.$footer = $('<div class="jq-modal-content-footer"></div>').appendTo(this.$content);
			this.$btn = $(`<button type="button" class="mui-btn" style="width: 100%;background: #2066DF;color: #fff;">${okText || '确定'}</button>`).click(() => {
				onOk ? onOk() : this.close();
			}).appendTo(this.$footer);
		}
		
		if (header) {
			this.$header = $(`<div class="jq-modal-content-header"><span class="jq-modal-content-header-title">${title}</span></div>`).prependTo(this.$content);
			this.$close = $('<i class="iconfont icon-shanchu"></i>').click(() => this.close()).appendTo(this.$header);
		}
		this.$modal.append(this.$content);
		
		this.$modal.click(function (event) {
			event.stopPropagation()
			_this.close();
		});
		
		this.$content.click(function (event) {
			event.stopPropagation()
		});
		$('body').append(this.$modal);
	}
	
	_proto.open = function () {
		this.$modal.fadeToggle(150);
	}
	
	_proto.close = function () {
		this.$modal.fadeToggle(150);
	}
})($, window.jqModal = new Function())