;
(function($) {
	const InitTable = function({
		column,
		datasource,
		clickHandle
	}) {
		this.column = column;
		this.datasource = datasource;
		this._length = this.column.length || 0;
		this.thWidth = (100 / this._length) + '%';
		this.clickHandle = clickHandle;
		this.tables = $('<table>').css({
			'width': '100%',
			'height': 'calc(100% - 1.226666rem)',
			'table-layout': 'fixed',
			'border-spacing': '0em',
		});
		this._init();
	}

	InitTable.prototype = {
		constructor: InitTable,
		_init: function() { 
 			this._setColumn();
			this._setBody();
			this._end();
		},
		// 设置头部
		_setColumn: function() {
			const thead = $('<thead>')
			const tr = $('<tr>').css({
				'height': '0.8rem',
				'line-height': '0.8rem',
				'background': '#2066DF',
				'font-size': '0.373333rem',
				'font-family': 'Source Han Sans CN',
				'font-weight': '400',
				'color': '#FFFFFF',
			}).appendTo(thead)
			this.column.forEach((item) => {
				const {
					key,
					title
				} = item;
				$('<th>', {
					text: title,
					click: (e) => this.theadClick(e, item)
				}).css({
					'display': 'inline-block',
					'width': this.thWidth,
					'text-align': 'center',
					'white-space': 'nowrap',
					'overflow': 'hidden',
					'text-overflow': 'ellipsis',
				}).appendTo(tr)
			})

			this.tables.append(thead)
		},
		_setBody: function() {
			const tbody = $('<tbody>').css({
				'display': 'block',
				'width': '100%',
				'overflow': 'auto',
				'height': '100%',
			})
			this.datasource.forEach((item) => {
				const tr = $('<tr>').css({
					'display': 'inline-block',
					'width': '100%',
					'height': '0.8rem',
					'line-height': '0.8rem',
				})

				this.column.forEach((i) => {
					const {
						key
					} = i;
					const {
						id
					} = i
					const value = item[key]
					$('<td>', {
						text: value,
						click: (e) => this.tdClick(e, item)
					}).css({
						'display': 'inline-block',
						'width': (100 / this._length) + '%',
						'text-align': 'center',
						'white-space': 'nowrap',
						'overflow': 'hidden',
						'text-overflow': 'ellipsis',
						'font-size': '0.32rem',
						'font-family': 'Source Han Sans CN',
						'font-weight': '400',
						'color': '#484848',
					}).appendTo(tr)
				})
				tbody.append(tr)
			})
			this.tables.append(tbody)

		},
		_end: function() {},
		theadClick: function(e, item) {
			console.log(e, item)
		},

		tdClick: function(e, item) {
			const {
				tdClick
			} = this.clickHandle;
			tdClick && tdClick(e, item)
		}
	}
	window.InitTable = InitTable;
}($))
