
var map = new AMap.Map('mapContainer', {
	center: [115.3626242, 28.8614724],
	viewMode: '2D',
	zoom: 10,
	resizeEnable: true
});
 var southWest = new AMap.LngLat(114.74609847143601, 28.679184393985356);
  var northEast = new AMap.LngLat(115.69762455279913, 29.13383001510663);
  var bounds = new AMap.Bounds(southWest, northEast);
  map.setLimitBounds(bounds);

// var imageLayer = new AMap.ImageLayer({
// 	url: 'https://amappc.cn-hangzhou.oss-pub.aliyun-inc.com/lbs/static/img/dongwuyuan.jpg',
// 	bounds: new AMap.Bounds( //113.5876,24.4971,118.4875,30.0786,
// 		[113.5876, 24.4971],
// 		[118.4875, 30.0786]
// 	),
// 	zooms: [1, 20]
// });
// var defaultLayer = new AMap.createDefaultLayer();
// var map = new AMap.Map('mapContainer', {
// 	center: [115.243447, 27.197877],
// 	zoom: 10,
// 	bounds: new AMap.Bounds( //113.5876,24.4971,118.4875,30.0786,
// 		[113.5876, 24.4971],
// 		[118.4875, 30.0786]
// 	),
// 	layers: [
// 		defaultLayer,
// 		// imageLayer,
// 	]
// });

// map.setBounds(new AMap.Bounds(
// 	[113.5876, 24.4971],
// 	[118.4875, 30.0786]
// ))
// map.setLimitBounds(new AMap.Bounds( 
// 	[113.5876, 24.4971],
// 	[118.4875, 30.0786]
// ));


// AMap.plugin([
// 	'AMap.ToolBar',
// ], function() {
// 	map.addControl(new AMap.ToolBar({
// 		// 简易缩放模式，默认为 false
// 		liteStyle: false
// 	}));
// });


//定位按钮
var options = {
	//'enableHighAccuracy': true,//是否使用高精度定位，默认:true
	'showButton': true, //是否显示定位按钮
	'buttonPosition': 'LB', //定位按钮的位置
	/* LT LB RT RB */
	'buttonOffset': new AMap.Pixel(10, 20), //定位按钮距离对应角落的距离
	'showMarker': true, //是否显示定位点
	'markerOptions': { //自定义定位点样式，同Marker的Options
		'offset': new AMap.Pixel(-18, -36),
		'content': '<img src="https://a.amap.com/jsapi_demos/static/resource/img/user.png" style="width:36px;height:36px"/>'
	},
	'showCircle': true, //是否显示定位精度圈
	'circleOptions': { //定位精度圈的样式
		'strokeColor': '#0093FF',
		'noSelect': true,
		'strokeOpacity': 0.5,
		'strokeWeight': 1,
		'fillColor': '#02B0FF',
		'fillOpacity': 0.25
	}
}

//定位
AMap.plugin(["AMap.Geolocation"], function() {
	var geolocation = new AMap.Geolocation(options);
	map.addControl(geolocation);
	//自动定位到目标点
	/* geolocation.getCurrentPosition(
		function(status, result) {
			if (status == 'complete') {
				onComplete(result)
			} else {
				onError(result)
			}
		}); */

});

AMap.plugin([
	'AMap.DistrictSearch',
], function() {
	var districtSearch = new AMap.DistrictSearch({
		// 关键字对应的行政区级别，共有5种级别
		level: 'province',
		//  是否显示下级行政区级数，1表示返回下一级行政区
		subdistrict: 0,
		// 返回行政区边界坐标点
		extensions: 'all',
	})

	// 搜索所有省/直辖市信息
	districtSearch.search('靖安', (status, result) => {
		// 查询成功时，result即为对应的行政区信息
		this.handlePolygon(result)
	})
});


function handlePolygon(result) {
	let bounds = result.districtList[0].boundaries
	if (bounds) {
		for (let i = 0, l = bounds.length; i < l; i++) {
			//生成行政区划polygon
			let polygon = new AMap.Polygon({
				map: this.map, // 指定地图对象
				strokeWeight: 2, // 轮廓线宽度
				strokeOpacity: 0.8,
				path: bounds[i], //轮廓线的节点坐标数组
				fillOpacity: 0.3, //透明度
				strokeColor: '#0055ff',
				fillColor: '#55b4ff',
			})
			polygon.on('click', (e) => {
				console.log("点击图层");
				var address;
				var lnglatXY = [e.lnglat.getLng(), e.lnglat.getLat()];
				/* geocoder.getAddress(lnglatXY, function(status, result) {
					if (status === 'complete' && result.info === 'OK') {
						address = result.regeocode.formattedAddress; //返回地址描述
						mui.fire(targetPage, 'eventLocation', {
							address: address,
							lng: e.lnglat.getLng(),
							lat: e.lnglat.getLat()
						});
						ws.close();
					}
				}); */
			})
		}
		// 地图自适应
		this.map.setFitView()
	}
}


var wmsJsxbasemap, wmsJsxcdw, wmsJsxskhp, wmsJsxsx, wmsJsxxzbj, wmsJsxxzdw, wmsJsxsgnq,
	wmsJsx1mimg;
/**
 * 创建geoserver服务
 * @param {Object} sLayerName 服务名称
 */
function creatGeoServer(sLayerName, isActive) {
	var serverLayerName = sLayerName
	switch (serverLayerName) {
		case app.jsxbasemap:
			if (isActive) {
				wmsJsxbasemap = getWmsLayer(serverLayerName);
			} else {
				wmsJsxbasemap.setMap(null);
			}
			break;
		case app.jsxcdw:
			if (isActive) {
				wmsJsxcdw = getWmsLayer(serverLayerName);
			} else {
				wmsJsxcdw.setMap(null);
			}
			break;
		case app.jsxskhp:
			if (isActive) {
				wmsJsxskhp = getWmsLayer(serverLayerName);
			} else {
				wmsJsxskhp.setMap(null);
			}
			break;
		case app.jsxsx:
			if (isActive) {
				wmsJsxsx = getWmsLayer(serverLayerName);
			} else {
				wmsJsxsx.setMap(null);
			}
			break;
		case app.jsxxzbj:
			if (isActive) {
				wmsJsxxzbj = getWmsLayer(serverLayerName);
			} else {
				wmsJsxxzbj.setMap(null);
			}
			break;

		case app.jsxxzdw:
			if (isActive) {
				wmsJsxxzdw = getWmsLayer(serverLayerName);
			} else {
				wmsJsxxzdw.setMap(null);
			}
			break;
		case app.jsxsgnq:
			if (isActive) {
				wmsJsxsgnq = getWmsLayer(serverLayerName);
			} else {
				wmsJsxsgnq.setMap(null);
			}
			break;
		case app.jsx1mimg:
			if (isActive) {
				wmsJsx1mimg = getWmsLayer(serverLayerName);
			} else {
				wmsJsx1mimg.setMap(null);
			}
			break;
		default:
			break;
	}
}

function getWmsLayer(serverLayerName) {
	var wms = new AMap.TileLayer.WMS({
		url: app.getGeoServerURL(),
		blend: true,
		zooms: [0, 19],
		tileSize: 256,
		params: {
			'LAYERS': 'jsxws:' + serverLayerName,
			FORMAT: 'image/png',
			Version: '1.1.0',
			'SRS': 'EPSG:3857'
		}
	})
	wms.setMap(map);
	return wms;
}

var jsxcdwJson, jsxsgnqJson, jsxskhpJson, jsxsxJson, jsxsxadJson, jsxsxhxxylJson, jsxsxylsndJson, jsxsxzdJson,
	jsxsxzlJson, jsxsydJson, jsxxzbjJson, jsxxzdwJson;

/**
 * 绘制geojson图层
 * @param {Object} geojson 数据
 * @param {Object} isActive 是否开启
 */
function setGeos(geojson, isActive) {
	var geojsonUrl = '../js/data/' + geojson + '.geojson';
	console.log('geojsonUrl===' + geojsonUrl);
	ajax(geojsonUrl, function(err, geoJSON) {
		if (!err) {
			switch (geojson) {
				case app.jsxcdwJson: //吉水县村点位
					jsxcdwJson = new AMap.GeoJSON({
						geoJSON: geoJSON,
					});
					jsxcdwJson.setMap(map);
					break;
				case app.jsxsgnqJson: //吉水县水功能区
					jsxsgnqJson = new AMap.GeoJSON({
						geoJSON: geoJSON,
						// 还可以自定义getMarker和getPolyline
						getPolygon: function(geojson, lnglats) {
							console.log('GeoJSON 数据加载完成===' + JSON.stringify(geojson))
							var name = geojson.properties._parentProperities.Name;
							var fillColors = "";
							console.log('GeoJSON 数据加载完成===' + JSON.stringify(name))
							switch (name) {
								case "工业用水区":
									fillColors = "#FFE5B2";
									break;
								case "饮用水区":
									fillColors = "#C1E9F7";
									break;
								case "过渡区":
									fillColors = "#9CFFF1";
									break;
								case "保留区":
									fillColors = "#ABD1AB";
									break;
								case "下饮水源去":
									fillColors = "#66A9FF";
									break;
								default:
									break;
							}
							// 计算面积
							var area = AMap.GeometryUtil.ringArea(lnglats[0])
							return new AMap.Polygon({
								path: lnglats,
								// fillOpacity: 1 - Math.sqrt(area / 8000000000), // 面积越大透明度越高
								strokeColor: "#55b4ff",
								fillColor: fillColors,
								strokeWeight: 2,
								strokeOpacity: 0.8,
								fillText: "dd",
								// fillOpacity: 0.3,
								// strokeStyle: 'dashed',
							});
						}
					});
					jsxsgnqJson.setMap(map);
					break;
				default:
					break;
			}
			console.log('GeoJSON 数据加载完成')
		} else {
			console.log('GeoJSON 服务请求失败')
		}
	})
}
