var ApiConfig = {
  i: 0,
  VER: '40',
  HOST: 'https://xxxxxxx.com',
  DEBUG: 1,
  WXHOST: 'http://xxxxxxxx.com',
  //分页
  PAGECOUNT: 20,
  CHECK_ORDER: 3,
  CHECK_TRADE_LOG: 3,
  CHECK_ORDER_COUNT: 0,
  //工作状态上报定位的时间
  UPLOADLOCATIONWORKTIME: 5 * 1000,
  //闲置状态上报定位的时间
  UPLOADLOCATIONTIME: 15 * 60 * 1000,
  //UPLOADLOCATIONTIME: 15 * 1000,
  //定位失败上报定位的时间
  UPLOCATIONERROR: 60 * 1000,
  //工作状态下的距离
  DISTANCEWORK: 120 / 3600 * 5 * 1000 * 5,
  //重复上报cid时间
  ISREPORTPUSHCID: 60 * 1000
}

if (ApiConfig.DEBUG) {
  ApiConfig.HOST = "https://addev.xxxxxxx.cn";
  ApiConfig.WXHOST = 'https://devwx.xxxxxxx.cn';
}

/**
 * 打印信息 debug模式打印 正式不打印
 * @param {Object} flag    标示
 * @param {Object} info    打印信息
 * @param {Object} isJson    是否是json类型
 */
ApiConfig.staticIsDebug = function (flag, info, isJson) {
  if (ApiConfig.DEBUG) {
    if (flag) {
      console.log('--' + flag + '--' + (isJson ? JSON.stringify(info) : info));
    } else {
      console.log('--flag--' + (isJson ? JSON.stringify(info) : info));
    }
  }
}

/**
 * 短弹窗提示
 * @param {Object} info        信息
 * @param {Object} isJson    是否是json类型
 */
ApiConfig.staticShowToast = function (info, isJson) {
  plus.nativeUI.toast((isJson ? JSON.stringify(info) : info), {
    duration: "short"
  });
}

/**
 * 长弹窗提示
 * @param {Object} info        信息
 * @param {Object} isJson    是否是json类型
 */
ApiConfig.staticShowLongToast = function (info, isJson) {
  plus.nativeUI.toast((isJson ? JSON.stringify(info) : info), {
    duration: "long"
  });
}

/**
 * 短弹窗提示  debug模式打印 正式不打印
 * @param {Object} info        信息
 * @param {Object} isJson    是否是json类型
 */
ApiConfig.staticToast = function (info, isJson) {
  if (ApiConfig.DEBUG) {
    plus.nativeUI.toast((isJson ? JSON.stringify(info) : info), {
      duration: "short"
    });
  }
}

var Utils = function () {
  this.PI = 3.14159265358979324;
  this.x_pi = 3.14159265358979324 * 3000.0 / 180.0;
  this.shopSignInitialize;
}

Utils.prototype.bd_decrypt = function (bdLat, bdLon) {
  var x = bdLon - 0.0065,
    y = bdLat - 0.006;
  var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * this.x_pi);
  var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * this.x_pi);
  var gcjLon = z * Math.cos(theta);
  var gcjLat = z * Math.sin(theta);
  return {
    'lat': gcjLat,
    'lon': gcjLon
  };
}

/**
 * 返回秒的时间戳 String
 */
Utils.prototype.phpTime = function () {
  var date = new Date();
  var timeInt = date.getTime();
  timeInt = (timeInt - (timeInt % 1000)) / 1000;
  return timeInt + "";
}

/**
 * 返回秒的时间戳 number
 */
Utils.prototype.phpTimeInt = function () {
  var date = new Date();
  var timeInt = date.getTime();
  timeInt = (timeInt - (timeInt % 1000)) / 1000;
  return timeInt;
}

/**
 * 获取地理位置方法
 * @param {Object} options  函数回调
 */
Utils.prototype.getGeoCode = function (options) {
  options = options || {};
  plus.geolocation.getCurrentPosition(function (position) {
    if (plus.os.name == "Android") {
      if (position.coords.latitude < 0.00000001) {
        options.onFailed && options.onFailed();
      } else {
        options.onSuccess && options.onSuccess(position);
      }
    } else {
      options.onSuccess && options.onSuccess(position);
    }
  }, function (error) {
    if (error.code == 13) {
      options.onFailed && options.onFailed();
    } else {
      ApiConfig.staticToast("获取定位位置信息失败：" + error.message);
    }
  }, {
    coordsType: "bd09ll",
    geocode: true,
    provider: 'baidu'
  });
}

/**
 * 解析地理位置的json数据
 * @param {Object} position  json类型的地址信息
 */
Utils.prototype.getAddressInfo = function (position) {
  var str = "";
  str += "地址：" + position.addresses + "\n"; //获取地址信息
  str += "坐标类型：" + position.coordsType + "\n";
  var timeflag = position.timestamp; //获取到地理位置信息的时间戳；一个毫秒数；
  str += "时间戳：" + timeflag + "\n";
  var codns = position.coords; //获取地理坐标信息；
  var lat = codns.latitude; //获取到当前位置的纬度；
  str += "纬度：" + lat + "\n";
  var longt = codns.longitude; //获取到当前位置的经度
  str += "经度：" + longt + "\n";
  var alt = codns.altitude; //获取到当前位置的海拔信息；
  str += "海拔：" + alt + "\n";
  var accu = codns.accuracy; //地理坐标信息精确度信息；
  str += "精确度：" + accu + "\n";
  var altAcc = codns.altitudeAccuracy; //获取海拔信息的精确度；
  str += "海拔精确度：" + altAcc + "\n";
  var head = codns.heading; //获取设备的移动方向；
  str += "移动方向：" + head + "\n";
  var sped = codns.speed; //获取设备的移动速度；
  str += "移动速度：" + sped;
  ApiConfig.staticIsDebug('getAdressInfo', position, 1);
  ApiConfig.staticToast(position, 1);
}

/**
 * 格式化时间年月
 */
Utils.prototype.formatYearMoney = function () {
  var date = new Date();
  var timeInt = date.getTime();
  var newTime = new Date(timeInt);
  var year = newTime.getFullYear() + '';
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month + '';
  return year + month;
}

/**
 * 格式化时间年月日
 */
Utils.prototype.formatYearMoneyDay = function () {
  var date = new Date();
  var timeInt = date.getTime();
  var newTime = new Date(timeInt);
  var year = newTime.getFullYear() + '';
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month + '';
  var day = newTime.getDate();
  day = day < 10 ? "0" + day : day;
  return year + month + day;
}

/**
 * 格式化时间年月日时分秒
 * @param {Object} time
 */
Utils.prototype.formatDate = function (time) {
  var newTime = new Date(time);
  var year = newTime.getFullYear();
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month;
  var day = newTime.getDate();
  day = day < 10 ? "0" + day : day;
  var hours = newTime.getHours();
  hours = hours < 10 ? "0" + hours : hours;
  var minutes = newTime.getMinutes();
  minutes = minutes < 10 ? "0" + minutes : minutes;
  var seconds = newTime.getSeconds();
  seconds = seconds < 10 ? "0" + seconds : seconds;
  return year + "-" + month + "-" + day + " " + hours + ":" + minutes + ":" + seconds;
}

/**
 * Fri Oct 31 18:00:00 UTC+0800 2008
 * @param {Object} time
 * @param {Object} format
 */

Utils.prototype.format = function (time, format) {
  var t = new Date(time);
  var tf = function (i) {
    return (i < 10 ? '0' : '') + i
  };
  return format.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
    switch (a) {
      case 'yyyy':
        return tf(t.getFullYear());
        break;
      case 'MM':
        return tf(t.getMonth() + 1);
        break;
      case 'mm':
        return tf(t.getMinutes());
        break;
      case 'dd':
        return tf(t.getDate());
        break;
      case 'HH':
        return tf(t.getHours());
        break;
      case 'ss':
        return tf(t.getSeconds());
        break;
    }
  })
}

/**
 * 根据时间字符获取年份
 * @param {Object} str
 */
Utils.prototype.getYearForString = function (str) {
  var oldTime = (new Date(str)).getTime();
  var newTime = new Date(oldTime);
  return newTime.getFullYear();
}

/**
 * 根据时间字符获取月份和日期
 * @param {Object} str
 */
Utils.prototype.getMonthForString = function (str) {
  var oldTime = (new Date(str)).getTime();
  var newTime = new Date(oldTime);
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month;
  var day = newTime.getDate();
  day = day < 10 ? "0" + day : day;
  return month + "/" + day
}

/**
 * 格式化时间年月日
 * @param {Object} time
 */
Utils.prototype.formatDay = function (time) {
  var newTime = new Date(time);
  var year = newTime.getFullYear();
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month;
  var day = newTime.getDate();
  day = day < 10 ? "0" + day : day;
  return year + "-" + month + "-" + day + " ";
}

/**
 * 格式化时间年月日
 * @param {Object} time
 */
Utils.prototype.formatDays = function (time) {
  var newTime = new Date(time);
  var year = newTime.getFullYear();
  var month = newTime.getMonth() + 1;
  month = month < 10 ? "0" + month : month;
  var day = newTime.getDate();
  day = day < 10 ? "0" + day : day;
  return year + "-" + month + "-" + day;
}

/**base64加密
 *
 * @param {Object} str
 */
Utils.prototype.base64_encode = function (str) {
  str = str + '';
  var c1, c2, c3;
  var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var i = 0,
    len = str.length,
    string = '';
  while (i < len) {
    c1 = str.charCodeAt(i++) & 0xff;
    if (i == len) {
      string += base64EncodeChars.charAt(c1 >> 2);
      string += base64EncodeChars.charAt((c1 & 0x3) << 4);
      string += "==";
      break;
    }
    c2 = str.charCodeAt(i++);
    if (i == len) {
      string += base64EncodeChars.charAt(c1 >> 2);
      string += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
      string += base64EncodeChars.charAt((c2 & 0xF) << 2);
      string += "=";
      break;
    }
    c3 = str.charCodeAt(i++);
    string += base64EncodeChars.charAt(c1 >> 2);
    string += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
    string += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
    string += base64EncodeChars.charAt(c3 & 0x3F)
  }
  return string;
}

/**
 * 获取地址信息
 * @param {Object} options
 */
Utils.prototype.getAddress = function (options) {
  options = options || {};
  this.getGeoCode({
    onSuccess: function (position) {
      if (position) {
        if ((position.addresses.indexOf('中国') >= 0)) {
          var newAddresses = position.addresses.replace('中国', '');
          options.onSuccess && options.onSuccess(newAddresses);
        } else {
          options.onSuccess && options.onSuccess(position.addresses);
        }
      }
    },
    onFailed: function () {
      
    }
  });
}

/**
 * 获取地址信息
 * @param {Object} options
 */
Utils.prototype.getAddressAndCoordinate = function (options) {
  var _this = this;
  try {
    options = options || {};
    _this.getGeoCode({
      onSuccess: function (position) {
        if (position) {
          if ((position.addresses.indexOf('中国') >= 0)) {
            var newAddresses = position.addresses.replace('中国', '');
            options.onSuccess && options.onSuccess({
              addresses: newAddresses,
              latitude: position.coords.latitude,
              longitude: position.coords.longitude
            });
          } else {
            options.onSuccess && options.onSuccess({
              addresses: position.addresses,
              latitude: position.coords.latitude,
              longitude: position.coords.longitude
            });
          }
        }
      },
      onFailed: function () {
        ApiConfig.staticShowToast('请打开定位权限');
      }
    })
  } catch (e) {
    ApiConfig.staticShowToast('请打开定位权限');
  }
}

/**
 * 判断是否有定位权限
 */
Utils.prototype.getLocationPermission = function () {
  var main = plus.android.runtimeMainActivity();
  var Build = plus.android.importClass("android.os.Build");
  var Manifest = plus.android.importClass("android.Manifest");
  var PackageManager = plus.android.importClass("android.content.pm.PackageManager");
  var Permission = Manifest.permission;
  var VERSION = Build.VERSION;
  var VERSION_CODES = Build.VERSION_CODES;
  var isCheck = Permission.ACCESS_FINE_LOCATION;
  var pkName = main.getPackageName();
  var packageManager = main.getPackageManager();
  console.log(isCheck);
  var GRANTED = '';
  if (VERSION.SDK_INT >= VERSION_CODES.M) {
    GRANTED = plus.android.invoke(main, 'checkSelfPermission', isCheck);
    alert(GRANTED);
    if (GRANTED == PackageManager.PERMISSION_DENIED) {
      console.log('没开启定位权限');
    } else {
      console.log('启定位权限');
    }
  } else {
    GRANTED = plus.android.invoke(packageManager, 'checkPermission', isCheck, pkName);
    alert(GRANTED);
    if (GRANTED == PackageManager.PERMISSION_DENIED) {
      console.log('没开启定位权限');
    } else {
      console.log('启定位权限');
    }
  }
}

/**
 * 封装mui.openWindow方法
 * @param {Object} openUrl String
 * @param {Object} openId  String
 * @param {Object} params  对象
 */
Utils.prototype.openWebView = function (openUrl, openId, params) {
  //关闭右滑关闭
  //			styles: {
  //				popGesture: 'none'
  //			},
  if (openUrl && openId) {
    mui.openWindow({
      url: openUrl,
      id: openId,
      popGesture: 'close',
      extras: params,
      createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
      show: {
        autoShow: true, //页面loaded事件发生后自动显示，默认为true
        aniShow: "slide-in-right" //页面显示动画，默认为”slide-in-right“；
      },
      waiting: {
        autoShow: true, //自动显示等待框，默认为true
        title: '正在加载...' //等待对话框上显示的提示内容
      }
    });
  } else {
    ApiConfig.staticShowToast('请求参数有问题！');
  }
}

/**
 * 更新分享服务
 * @param {Object} onSuccess
 */
Utils.prototype.updateService = function (onSuccess) {
  plus.share.getServices(function (services) {
    var shares = {};
    for (var i in services) {
      var t = services[i];
      shares[t.id] = t;
    }
    if (typeof onSuccess == "function")
      onSuccess(shares);
  }, function (e) {
    ApiConfig.staticShowToast('获取分享服务列表失败' + e.message);
  });
}

Utils.prototype.visitOperation = function () {
  var bts = [];
  var userInfo = DbUtils.getStorage('userInfo', 1);
  if (Constant.userType.ADMIN == userInfo.admin_group) {
    var openUrl = 'sell_shop/shop_filter.html';
    var openId = 'shop_filter.html';
    utilsJs.openWebView(openUrl, openId, undefined);
  } else {
    bts = [{
      title: '新建访店记录'
    }, {
      title: '筛选访店记录'
    }];
    plus.nativeUI.actionSheet({
        cancel: "取消",
        buttons: bts
      },
      function (e) {
        var openUrl = '';
        var openId = '';
        var i = e.index;
        if (i > 0) {
          switch (i) {
            case 1:
              openUrl = 'sell_shop/staff_operate/visit_shop.html';
              openId = 'visit_shop';
              utilsJs.openWebView(openUrl, openId, undefined);
              break;
            case 2:
              openUrl = 'sell_shop/visit_shop_filter.html';
              openId = 'visit_shop_filter.html';
              utilsJs.openWebView(openUrl, openId, undefined);
              break;
            default:
              break;
          }
        }
      }
    );
  }
}

/**
 * 商户操作
 */
Utils.prototype.shopOperation = function () {
  var bts = [];
  var userInfo = DbUtils.getStorage('userInfo', 1);
  if (Constant.userType.ADMIN == userInfo.admin_group) {
    var openUrl = 'sell_shop/shop_filter.html';
    var openId = 'shop_filter.html';
    utilsJs.openWebView(openUrl, openId, undefined);
  } else {
    bts = [{
      title: '新建合作商户'
    }, /* {
     title: '微信企业绑定'
     },*/ {
      title: '筛选商户'
    }];
    plus.nativeUI.actionSheet({
        cancel: "取消",
        buttons: bts
      },
      function (e) {
        var openUrl = '';
        var openId = '';
        var i = e.index;
        if (i > 0) {
          switch (i) {
            case 1:
              openUrl = 'sell_shop/shop_details/add_user.html';
              openId = 'add_user';
              utilsJs.openWebView(openUrl, openId, undefined);
              break;
            case 2:
              openUrl = 'sell_shop/shop_filter.html';
              openId = 'shop_filter.html';
              utilsJs.openWebView(openUrl, openId, undefined);
              /* openUrl = 'sell_shop/staff_operate/shop_member.html';
               openId = 'shop_member.html';
               utilsJs.openWebView(openUrl, openId, undefined);*/
              break;
            case 3:
              openUrl = 'sell_shop/shop_filter.html';
              openId = 'shop_filter.html';
              utilsJs.openWebView(openUrl, openId, undefined);
              break;
            default:
              break;
          }
        }
      }
    );
  }
}

/**
 * 初始化分享
 * @param {Object} shares
 * @param {Object} shop
 * @param {Object} isSign
 */
Utils.prototype.shareInitialize = function (shares, shop, isSign) {
  var _this = this;
  if (!shares) {
    _this.updateService(function (onSuccess) {
      shares = onSuccess;
    });
  }
  var ids = null;
  var bts = null;
  if (isSign) {
    ids = [{
      id: "weixin",
      ex: "WXSceneSession"
    }];
    bts = [{
      title: '标记商铺地址'
    }];
  } else {
    ids = [{
      id: "mark_shops"
    }, {
      id: "weixin",
      ex: "WXSceneSession"
    }];
    bts = [{
      title: '标记商铺'
    }, {
      title: '标记商铺地址'
    }];
  }
  plus.nativeUI.actionSheet({
      cancel: "取消",
      buttons: bts
    },
    function (e) {
      var i = e.index;
      if (i > 0) {
        _this.shareAction(ids[i - 1].id, ids[i - 1].ex, shares, shop);
      }
    }
  );
}

/**
 * 商户详情操作
 * @param {Object} shop
 */
Utils.prototype.shopDetailsOperation = function (shop) {
  var _this = this;
  var bts = [];
  var wasteShop = shop.waste_shop;
  var problemRecord = shop.problem_record;
  var userInfo = DbUtils.getStorage('userInfo', 1);
  if (Constant.userType.STAFF_ADMIN == userInfo.admin_group && wasteShop && wasteShop.status == 1) {
    bts = [{
      title: '编辑商户'
    }, {
      title: '新建维护记录'
    }, {
      title: '问题店'
    }, {
      title: '申请废店'
    }, {
      title: '审核废店'
    }, {
      title: '解决问题店'
    }];
  } else if (Constant.userType.STAFF_ADMIN == userInfo.admin_group && problemRecord && problemRecord.status == 1) {
    bts = [{
      title: '编辑商户'
    }, {
      title: '新建维护记录'
    }, {
      title: '问题店'
    }, {
      title: '申请废店'
    }, {
      title: '解决问题店'
    }];
  } else if (Constant.userType.STAFF_ADMIN == userInfo.admin_group && wasteShop && wasteShop.status == 1) {
    bts = [{
      title: '编辑商户'
    }, {
      title: '新建维护记录'
    }, {
      title: '问题店'
    }, {
      title: '申请废店'
    }, {
      title: '审核废店'
    }];
  } else {
    bts = [{
      title: '编辑商户'
    }, {
      title: '新建维护记录'
    }, {
      title: '问题店'
    }, {
      title: '申请废店'
    }];
  }
  plus.nativeUI.actionSheet({
      cancel: "取消",
      buttons: bts
    },
    function (e) {
      var openUrl = '';
      var openId = '';
      var i = e.index;
      if (i > 0) {
        switch (i) {
          case 1:
            utilsJs.updateShopView(shop);
            break;
          case 2:
            openUrl = '../staff_operate/maintain_shop.html';
            openId = 'maintain_shop';
            utilsJs.openWebView(openUrl, openId, {shop: shop});
            break;
          case 3:
            openUrl = '../staff_operate/produce_shop.html';
            openId = 'produce_shop';
            utilsJs.openWebView(openUrl, openId, {shop: shop});
            break;
          case 4:
            openUrl = '../staff_operate/wasteShop.html';
            openId = 'wasteShop';
            utilsJs.openWebView(openUrl, openId, {shop: shop});
            break;
          case 5:
            if (bts[i - 1].title == '审核废店') {
              _this.layerOpenView({
                title: '废店审核通过原因',
                content: '<textarea id ="remarkContent" rows="3" cols="20" style="box-shadow:0px 0px 0px rgba(0,0,0,0); resize:none;' +
                '-webkit-appearance:none; font-size: 0.16rem; border:none; width: 100%; height: 100%; ' +
                '-webkit-user-select: text; outline: none;"></textarea>',
                btn: ["审核不通过", "审核通过"],
                shadeClose: true,
                onFailed: function () {
                  var inputText = document.getElementById('remarkContent').value;
                  if (!inputText) {
                    ApiConfig.staticShowToast('请填写废店不审核通过原因');
                    return;
                  }
                  dpHttp.applyWasteShop({
                    type: 3,
                    shop_id: shop._id,
                    described: inputText,
                    onSuccess: function () {
                      ApiConfig.staticShowToast('申请成功');
                    }
                  })
                },
                onSuccess: function () {
                  var inputText = document.getElementById('remarkContent').value;
                  if (!inputText) {
                    ApiConfig.staticShowToast('请填写废店审核通过原因');
                    return;
                  }
                  dpHttp.applyWasteShop({
                    type: 2,
                    shop_id: shop._id,
                    described: inputText,
                    onSuccess: function () {
                      ApiConfig.staticShowToast('申请成功');
                    }
                  })
                }
              });
            } else {
              _this.layerOpenView({
                title: '问题解决描述',
                content: '<textarea id ="remarkContent" rows="3" cols="20" style="box-shadow:0px 0px 0px rgba(0,0,0,0); resize:none;' +
                '-webkit-appearance:none; font-size: 0.16rem; border:none; width: 100%; height: 100%; ' +
                '-webkit-user-select: text; outline: none;"></textarea>',
                btn: ["取消", "确定"],
                shadeClose: true,
                onSuccess: function () {
                  var inputText = document.getElementById('remarkContent').value;
                  if (!inputText) {
                    ApiConfig.staticShowToast('请填写问题解决描述');
                    return;
                  }
                  dpHttp.applyProblemRecord({
                    type: 2,
                    shop_id: shop._id,
                    resolution_described: inputText,
                    onSuccess: function () {
                      ApiConfig.staticShowToast('提交成功');
                    }
                  });
                }
              })
            }
            break;
          case 6:
            _this.layerOpenView({
              title: '问题解决描述',
              content: '<textarea id ="remarkContent" rows="3" cols="20" style="box-shadow:0px 0px 0px rgba(0,0,0,0); resize:none;' +
              '-webkit-appearance:none; font-size: 0.16rem; border:none; width: 100%; height: 100%; ' +
              '-webkit-user-select: text; outline: none;"></textarea>',
              btn: ["取消", "确定"],
              shadeClose: true,
              onSuccess: function () {
                var inputText = document.getElementById('remarkContent').value;
                if (!inputText) {
                  ApiConfig.staticShowToast('请填写问题解决描述');
                  return;
                }
                dpHttp.applyProblemRecord({
                  type: 2,
                  shop_id: shop._id,
                  resolution_described: inputText,
                  onSuccess: function () {
                    ApiConfig.staticShowToast('提交成功');
                  }
                });
              }
            });
            break;
          default:
            break;
        }
      }
    }
  );
}

Utils.prototype.layerOpenView = function (options) {
  options = options || {};
  layerOpen({
    "title": options.title,
    "content": options.content,
    "btn": options.btn,
    "shadeClose": options.shadeClose,
    "event": [function () {
      options.onFailed && options.onFailed()
    }, function () {
      options.onSuccess && options.onSuccess()
    }]
  });
}

Utils.prototype.updateShopView = function (shop) {
  var bts = [{
    title: '编辑基本信息'
  }, {
    title: '编辑提现信息'
  }, /*{
   title: '编辑活动信息'
   },*/ /*{
   title: '编辑奖励信息'
   },*/ {
    title: '编辑照片信息'
  }];
  plus.nativeUI.actionSheet({
      cancel: "取消",
      buttons: bts
    },
    function (e) {
      var openUrl = '';
      var openId = '';
      var i = e.index;
      if (i > 0) {
        switch (i) {
          case 1:
            openUrl = 'update_basic_shop.html';
            openId = 'update_basic_shop';
            break;
          case 2:
            openUrl = 'update_withdraw_shop.html';
            openId = 'update_withdraw_shop';
            break;
          case 3:
            openUrl = 'update_photo_shop.html';
            openId = 'update_photo_shop';
            /* openUrl = 'update_activity_shop.html';
             openId = 'update_activity_shop';*/
            break;
          case 4:
            openUrl = 'update_photo_shop.html';
            openId = 'update_photo_shop';
            break;
          default:
            break;
        }
        if (openUrl) {
          utilsJs.openWebView(openUrl, openId, {shop: shop});
        }
      }
    }
  );
}

/**
 * 分享操作
 * @param {Object} id
 * @param {Object} ex
 * @param {Object} shares
 * @param {Object} shop
 */
Utils.prototype.shareAction = function (id, ex, shares, shop) {
  var _this = this;
  var s = null;
  if (id == 'weixin') {
    if (!id || !(s = shares[id])) {
      ApiConfig.staticIsDebug("无效的分享服务！");
      console.log("无效的分享服务！");
      return;
    }
    if (s.authenticated) {
      _this.shareMessage(s, ex, shop);
    } else {
      s.authorize(function () {
        _this.shareMessage(s, ex, shop);
      }, function (e) {
        ApiConfig.staticIsDebug("认证授权失败：" + e.code + " - " + e.message);
        console.log("认证授权失败：" + e.code + " - " + e.message);
      });
    }
  } else {
    var sign = _this.getShopSign(shop._id);
    _this.shopSignInitialize && _this.shopSignInitialize(sign);
  }
}

/**
 * 发送分享
 * @param {plus.share.ShareService} s
 * @param {Object} ex
 * @param {Object} shop
 */
Utils.prototype.shareMessage = function (s, ex, shop) {
  this.getAddressAndCoordinate({
    onSuccess: function (position) {
      var msg = {
        content: '地址：' + position.addresses + '  纬度：' + position.latitude + '  ' +
        '  经度：' + position.longitude + '  ' + '商户名：' + shop.name,
        extra: {
          scene: ex
        }
      };
      s.send(msg, function () {
        ApiConfig.staticIsDebug("分享到\"" + s.description + "\"成功！");
        console.log("分享到\"" + s.description + "\"成功！");
      }, function (e) {
        ApiConfig.staticIsDebug("分享到\"" + s.description + "\"失败: " + e.code + " - " + e.message);
        console.log("分享到\"" + s.description + "\"失败: " + e.code + " - " + e.message);
      });
    },
    onFailed: function () {
    }
  });
}

Utils.prototype.uploadPictures = function (options) {
  var _this = this;
  options = options || {};
  var element = options.element;
  var quality = options.quality;
  var category = options.category;
  var overwrite = options.overwrite;
  var defaultPic = options.defaultPic;
  var defaultPath = options.defaultPath;
  var overWriteName = options.overWriteName;
  if (element) {
    element.addEventListener('tap', function () {
      _this.selectUploadWay({
        element: element,
        quality: quality,
        category: category,
        overwrite: overwrite,
        defaultPic: defaultPic,
        defaultPath: defaultPath,
        overWriteName: overWriteName,
        onSuccess: function (responseJson) {
          options.onSuccess && options.onSuccess(responseJson);
        },
        onFailed: function (errorJson) {
          options.onFailed && options.onFailed(errorJson);
        },
        onCompleted: function () {
          options.onCompleted && options.onCompleted();
        }
      });
    })
  }
}

Utils.prototype.selectUploadWay = function (options) {
  options = options || {};
  var _this = this;
  var element = options.element;
  var defaultPic = options.defaultPic;
  var defaultPath = options.defaultPath;
  var overWriteName = options.overWriteName;
  var bts = [{
    title: '相册'
  }, {
    title: '拍照'
  }, {
    title: '删除'
  }];
  plus.nativeUI.actionSheet({
      cancel: "取消",
      buttons: bts
    },
    function (e) {
      var i = e.index;
      switch (i) {
        case 1:
          // 从相册添加文件
          plus.gallery.pick(function (path) {
            _this.uploadPictureHandle({
              src: path,
              dst: options.dst,
              quality: options.quality,
              element: options.element,
              category: options.category,
              overwrite: options.overwrite,
              overWriteName: overWriteName,
              onSuccess: function (responseJson) {
                options.onSuccess && options.onSuccess(responseJson);
              },
              onFailed: function (errorJson) {
                options.onFailed && options.onFailed(errorJson);
              },
              onCompleted: function () {
                options.onCompleted && options.onCompleted();
              }
            })
          });
          break;
        case 2:
          // 拍照添加文件
          plus.camera.getCamera().captureImage(function (path) {
            _this.uploadPictureHandle({
              src: path,
              dst: options.dst,
              quality: options.quality,
              element: options.element,
              category: options.category,
              overwrite: options.overwrite,
              overWriteName: overWriteName,
              onSuccess: function (responseJson) {
                options.onSuccess && options.onSuccess(responseJson);
              },
              onFailed: function (errorJson) {
                options.onFailed && options.onFailed(errorJson);
              },
              onCompleted: function () {
                options.onCompleted && options.onCompleted();
              }
            })
          });
          break;
        case 3:
          if (element.src.indexOf(defaultPic) >= 0) {
            ApiConfig.staticShowToast('当前未上传图片，无法删除');
          } else {
            element.src = defaultPath;
          }
          break;
        default:
          break;
      }
    }
  );
}

Utils.prototype.uploadPictureHandle = function (options) {
  options = options || {};
  var element = options.element;
  var overWriteName = options.overWriteName;
  if (!options.overwrite) {
    overWriteName = '_doc/default.jpg';
  }
  plus.zip.compressImage({
      src: options.src,
      dst: overWriteName,
      quality: options.quality || 20,
      overwrite: options.overwrite || true
    },
    function (event) {
      dpHttp.upLoadPictureHttp({
        files: event.target,
        category: options.category,
        onSuccess: function (responseJson) {
          element.src = responseJson.url;
          options.onSuccess && options.onSuccess(responseJson);
        },
        onFailed: function (errorJson) {
          options.onFailed && options.onFailed(errorJson);
        },
        onCompleted: function () {
          options.onCompleted && options.onCompleted();
        }
      });
    },
    function (error) {
      options.onFailed && options.onFailed(error);
      console.log(JSON.stringify(error));
    }
  );
}

//是否有权限登陆
Utils.prototype.checkPermissions = function (admin) {
  //|| Constant.userType.STAFF_ADMIN == admin
  if (Constant.userType.DRIVER == admin || Constant.userType.STAFF == admin
    || Constant.userType.ADMIN == admin || Constant.userType.DISPATCHER == admin
    || Constant.userType.WORKSHOP_DIRECTOR == admin) {
    return true;
  } else {
    return false;
  }
}

/**
 * 存储标记商户标签
 * @param {Object} key   商户id
 * @param {Object} value 表示内容
 */
Utils.prototype.saveShopSign = function (key, value) {
  plus.storage.setItem(key, value);
}

/**
 * 获取标记商户标签
 * @param {Object} key 商户id
 */
Utils.prototype.getShopSign = function (key) {
  return plus.storage.getItem(key);
}

/**
 * 删除标记商户标签
 * @param {Object} key
 */
Utils.prototype.removeShopSign = function (key) {
  plus.storage.removeItem(key);
}

/**
 * 获取设备的名称
 */
Utils.prototype.getDeviceName = function () {
  var Build = plus.android.importClass("android.os.Build");
  var build = new Build();
  return plus.android.getAttribute(build, "MODEL");
}

/**
 * 获取android系统的版本号
 */
Utils.prototype.getOS = function () {
  var Build = plus.android.importClass("android.os.Build");
  var VERSION = Build.VERSION;
  var version = new VERSION();
  return "Android" + plus.android.getAttribute(version, "RELEASE");
}

/**
 * 获取androidId
 */
Utils.prototype.getAndroidId = function () {
  var Settings = plus.android.importClass("android.provider.Settings");
  var settings = new Settings();
  var Secure = settings.Secure;
  var secure = new Secure();
  var ANDROID_ID = Secure.ANDROID_ID;
  var main = plus.android.runtimeMainActivity();
  var getContentResolver = main.getContentResolver();
  return plus.android.invoke(secure, "getString", getContentResolver, ANDROID_ID + "");
}

/**
 * 获取IMEI
 */
Utils.prototype.getIMEIStatus = function () {
  var Context = plus.android.importClass("android.content.Context");
  var ActivityManager = plus.android.importClass("android.app.ActivityManager");
  var activityService = plus.android.runtimeMainActivity().getSystemService(Context.TELEPHONY_SERVICE);
  return plus.android.invoke(activityService, "getDeviceId");
}

/**
 * 获取设备的唯一unionid
 */
Utils.prototype.getDeviceId = function () {
  return hex_sha1(this.getAndroidId() + this.getDeviceName() + this.getIMEIStatus() + this.getOS());
}